\ 68332 polled serial communications driver

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 2380 631441
        fax: +44 2380 339691
        net: mpe@mpeltd.demon.co.uk
             tech-support@mpeltd.demon.co.uk
        web: www.mpeltd.demon.co.uk
))

only forth definitions
hex

\ --------------------------------------------------------------------------

\ This next word takes the system clock rate (in HZ) and the required serial
\ comms rate (in BPS) and returns a system-dependant number of parameters that
\ should be sufficent to effect the baud rate selection by initialising the
\ correct hardware.

interpreter
: gen-baud-rate         ( clk-rate bps-rate -- sys-scbr )
  #32 * /
;
target

system-speed console-speed gen-baud-rate equ sys-scbr

\ ------------------------------------------------------------------------------
\       serial communication low level drivers
\ ------------------------------------------------------------------------------

Code init-ser	\ -- ; initialise SCI & set baud rate
  # QMCR a0 l. movea,                   \ point to QSM
  # $0000 &SCCR1 d(a0) w. move,         \ clear SCCR1 to disable everything
  # sys-scbr &SCCR0 d(a0) w. move,      \ SCCR0, set to required baud rate, etc.
  # $002c &SCCR1 d(a0) w. move,         \ re-enable transmitter and receiver
  next,
End-Code

Code (Ser-emit)         \ char -- ; transmit character on SCI
  # QMCR a0 l. movea,
  begin,  $0c d(a0) d2 w. move,
          # $00100 d2 w. andi,
  ne, until,
  d7 $0e d(a0) w. move,
  (a6)+ d7 l. move,
  next,
End-Code

Code (Ser-key)          \ -- char ; receive character on SCI
  d7 -(a6) move,
  # QMCR a0 l. movea,
  begin,  $0c d(a0) d2 w. move,
          # $00040 d2 w. andi,
  ne, until,
  d7 l. clr,  $0e d(a0) d7 w. move,
  # $00FF d7 w. andi,
  next,
End-Code

Code (Ser-key?)         \ -- flag ; test if SCI has received character
  d7 -(a6) move,
  # QMCR a0 l. movea,
  $0C d(a0) d2 w. move,
  # $00040 d2 w. andi,
  pqkey1 beq,
  # -1 d7 l. moveq,
  next,
l: pqkey1
  # 0 d7 l. moveq,
  next,
End-Code


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mser-key)	\ -- char ; tasks wile waiting
  begin
    (ser-key?) 0=
   while
    pause
  repeat
  (ser-key@)
;
[then]

: (ser-TYPE)	\ c-addr len --
  bounds
  ?do  i c@ (seremit)  loop
;

: (ser-CR)	\ --
  $0D (seremit)  $0A (seremit)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mser-key) ,
[else]
  ' (ser-key) ,		\ -- char ; receive char
[then]
  ' (ser-key?) ,	\ -- flag ; check receive char
  ' (ser-emit) ,	\ -- char ; display char
  ' (ser-type) ,	\ caddr len -- ; display string
  ' (ser-cr) ,		\ -- ; display new line

decimal

