\ FS332 Forth Systeme 68332 SBC simple LED driver

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 2380 631441
        fax: +44 2380 339691
        net: mpe@mpeltd.demon.co.uk
             tech-support@mpeltd.demon.co.uk
        web: www.mpeltd.demon.co.uk
))

$F00000         constant PIT
$D00000         constant RTC
$FA0000         constant CSEXT
$A00000         constant FLASH

PIT $09 +       constant PortB          \ o/p port (config needs setting to FF)
PIT $0A +       constant PortA          \ i/p port (default reset port setting)
PIT $03 +       constant Portbconfig

\ ------------------------------------------------------------------------------
\       basic LED functions
\ ------------------------------------------------------------------------------

: led-mask-off  ( mask -- )
  portb c@ or portb c!
;

: led-mask-on   ( mask -- )
  not
  portb c@ and portb c!
;

: led-on        (  -- ; turn *all* LEDs on )
  $FF led-mask-on
;

: led-off       (  -- ; turn *all* LEDs off )
  $FF led-mask-off
;

: led-init      (  -- ; initialise LED for use, LED is left off )
  $FF portbconfig c!
  led-off
;

[defined] ms
[if]
  : led-blip
    led-off #333 ms
    led-on  #333 ms
    led-off #333 ms
  ;
[then]

: wait
35000 0 do loop 
;

: cy
led-off
1 led-mask-on
wait
led-off
2 led-mask-on
wait
led-off
4 led-mask-on
wait
led-off
8 led-mask-on
wait
led-off
16 led-mask-on
wait
led-off
32 led-mask-on
wait
led-off
64 led-mask-on
wait
led-off
128 led-mask-on
wait
led-off
;

: cy-bw
128 led-mask-on
wait
led-off
64 led-mask-on
wait
led-off
32 led-mask-on
wait
led-off
16 led-mask-on
wait
led-off
8 led-mask-on
wait
led-off
4 led-mask-on
wait
led-off
2 led-mask-on
wait
led-off
1 led-mask-on
wait
led-off
;

: cylon
begin
cy
wait wait wait wait wait wait
cy-bw
wait wait wait wait wait wait
key?
until
;

create Kitlut
  %00000001 c,
  %00000011 c,
  %00000111 c,
  %00001111 c,
  %00011110 c,
  %00111100 c,
  %00111100 c,
  %01111000 c,
  %11110000 c,
  %11100000 c,
  %11000000 c,
  %10000000 c,
  %00000000 c, 
  %10000000 c,
  %11000000 c,
  %11100000 c,
  %11110000 c,
  %01111000 c,
  %00111100 c,
  %00111100 c,
  %00011110 c,
  %00001111 c,
  %00000111 c,
  %00000011 c,
  %00000001 c,
  %00000000 c,

: kit 
  begin
    26 0 do
      i kitlut + c@ led-mask-on
      wait
      led-off
    loop
    key?
  until
;
