\ ColdFire SBC5206 dev board serial drivers provided by MC68HC901 chip
\ Transmit and receive signals available on J5

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE


20000630 SFP001 Converted to v6.1 code model
))


\ ------------------------------------------------------------------------------
\       MC68HC901 register map

\ To provide the SBC5206 dev board with one independent serial comms channel
\ for dBUG communication with terminal or PC, an MC68HC901 is used. This
\ device provides four channels (A, B, C and D), one serial communication
\ channel, and 8 input lines. Channel D timer is used as the baud rate
\ generator for the serial communication channel.

\ The clock source for the timers is the 2.4576MHz crystal. The clock signal
\ logic is one-fourth of the processor's clock.

\ The chip select 2 is used to access the MC68HC901 internal registers. This
\ is mapped to $30000000. The chip select 1 is programmed to generate an
\ Interrupt Acknowledge signal to drive the -IACK of the MC68HC901.

$03000		       	equ 68C901_AREA
68C901_AREA $10000 *    equ 68C901_BASE

$00 68C901_BASE +	equ GPDR
$01 68C901_BASE +	equ AER
$02 68C901_BASE +	equ DDR
$03 68C901_BASE +	equ IERA
$04 68C901_BASE +	equ IERB
$05 68C901_BASE +	equ IPRA
$06 68C901_BASE +	equ IPRB
$07 68C901_BASE +	equ ISRA
$08 68C901_BASE +	equ ISRB
$09 68C901_BASE +	equ IMRA
$0a 68C901_BASE +	equ IMRB
$0b 68C901_BASE +	equ VR  
$0c 68C901_BASE +	equ TACR
$0d 68C901_BASE +	equ TBCR
$0e 68C901_BASE +	equ TCDCR
$0f 68C901_BASE +	equ TADR
$10 68C901_BASE +	equ TBDR
$11 68C901_BASE +	equ TCDR
$12 68C901_BASE +	equ TDDR
$13 68C901_BASE +	equ SCR 
$14 68C901_BASE +	equ UCR 
$15 68C901_BASE +	equ RSR 
$16 68C901_BASE +	equ TSR 
$17 68C901_BASE +	equ UDR 

\ ------------------------------------------------------------------------------
\       Serial communications low-level drivers

: (Key3?)       \ -- flag
  RSR c@ $80 and 0<> 	\ test for character present
;

: (Key3)        \ -- char
  Begin
    RSR c@ $80 And 0<>
  Until
  UDR c@
;

: (Emit3)       \ char --
  begin
    TSR c@ $80 and	\ test safe to transmit
    0<>
  until
  UDR c!		\ write character
  5 TSR c! 		\ op high and enable tx
;

: init-ser	\ --
  $01 TDDR c!           \ setup clock rate 307.2 kHz
  $01 TCDCR c!          \ Enable timer D delay mode 1/4
  $88 UCR c!            \ 1/16, 8 bits, 1 start, 1 stop, no parity
  $05 TSR c!            \ enable TX
  $01 RSR c!            \ enable RX
;


\ ***********************
\ Generic i/o assignments
\ ***********************

internal

tasking? [if]
: (mkey3)	\ -- char ; tasks wile waiting
  begin
    (key3?) 0=
   while
    pause
  repeat
  (key3)
;
[then]

: (TYPE3)	\ c-addr len --
  bounds
  ?do  i c@ (emit3)  loop
;

: (CR3)		\ --
  $0D (emit3)  $0A (emit3)
;

external

cdata
create Console	\ -- addr ; OUT managed by upper driver
tasking? [if]
  ' (mkey3) ,
[else]
  ' (key3) ,		\ -- char ; receive char
[then]
  ' (key3?) ,		\ -- flag ; check receive char
  ' (emit3) ,		\ -- char ; display char
  ' (type3) ,		\ caddr len -- ; display string
  ' (cr3) ,		\ -- ; display new line

decimal

