\ 68307 generic startup code

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE


20000630 SFP005 Converted to v6.1
19981019 MSD004 Converted for optimised model (A3 == 0).
19980422 MSD003 Brought into line with the INIT*.FTH and *.CTL from the other
         MSD003 chips.  All of the start-up assembler that *was* in the .CTL
         MSD003 file has been moved into *here*.  (Not flagged.)
19980416 MSD002 Revamp the code that calls the turn-key start up word.
19980917 MSD001 Revert to old treatment of CLD1 whereby it holds an *address*
         MSD001 rather than a *call* to an address.  As a by-product, WRM1
         MSD001 removed as being unnecessary.
))


\ ------------------------------------------------------------------------------
\       start up table and entry points
\ ------------------------------------------------------------------------------

l: START-VECTOR                         \ start up vector
  INIT-S0 ,                             \ top of data stack
  0 ,                                   \ PC entry point, filled in later

here $0400 8 - erase                    \ clear vector area

start-vector $0400 + Corg               \ reserve space for ROM vectors

L: CLD1
  0 ,					\ filled in later 


\ start up code is compiled straight after the vector table as it has to exist
\ in the first 8Kbytes from address zero - 8Kb is the reset size of Option
\ Register 0, which limits the EPROM (CS0) block size.

asmcode

l: start307
\ Main System Configuration:
\   BusWidth CS1 = 8bit
\   all other values as per reset
  # $02700      sr              w. move,        \ supervisor mode, only int level 7
  # $0003F010   $l SCR          l. move,        \ set system configuration

\ set location of SIM module registers at $100000
  # initMBAR    $ MBAR          w. move,	\ register base = $100000, CFC = 0
  # MBASE       a0              l. movea,       \ a0 points to register base

\ Memory block management:
\   (CS0) EPROM is located at address 0
\   (CS0) EPROM block size set by OR0 to 512Kb with 0 wait states
\   (CS1) RAM is located at address $180000
\   (CS1) RAM block size set by OR1 to 512Kb with 0 wait states
  # $C001       BR0 d(a0)       w. move,        \ set EPROM base to $000000
  # $1F00       OR0 d(a0)       w. move,        \ set EPROM size and wait states
  # $0301       BR1 d(a0)       w. move,        \ set RAM base to $180000
  # $1F00       OR1 d(a0)       w. move,        \ set RAM size and wait states

\ clear the RAM CS latch by reading RAM address at least 32 times
\ CMS micro module specific...
  # $FF         d0              w. move,
l: RLOOP
  $l $180000    d1              b. move,
  d0            RLOOP           dbra,

\ turn the watchdog off
  # $0          WRR d(a0)       w. move,

\ Join main Forth entry point
L: ECLD
  # init-s0 a6 l. movea,                \ set data stack
  # init-r0 a7 l. movea,                \ set return stack
  # init-u0 a5 l. movea,                \ set user pointer
                                        \ A4 = locals pointer, self setting
  # 0 a3 l. movea,                      \ the system needs A3=0

  $l cld1 a1 l. movea,                  \ get address of word to run
  (a1) jsr,                             \ run it
  ecld bra,                             \ should never happen, but ...
end-code
start307 start-vector 4 + !             \ patch up entry vector


\ ------------------------------------------------------------------------------
\       reset values for user and system variables
\ ------------------------------------------------------------------------------

[undefined] umbilical? [if]
  \ initial values of user variables
  L: USER-RESET
    init-s0 ,   init-r0 ,               \ s0, r0
    0 ,  0 ,                            \ #tib, span
    0 ,  0 ,                            \ >in, out
    $0A ,  0 ,                          \ base, hld

  \ initial values of system variables
  L: INIT-FENCE 0 ,                     \ fence
  L: INIT-DP 0 ,                        \ dp
  L: INIT-VOC-LINK 0 ,                  \ voc-link
[then]

