\ 68000 ANS Local variables extensions

\ 19990413 SFP004 Convert RELLVS to use the PRACTICAL frame order, and to
\                 make frames completely interrupt safe. The scratch area
\                 of the frame is used as follows:
\                       4 (a4)  Previous Return stack pointer
\                       0 (a4)  Previous Frame pointer
\ 19981019 MSD003 Altered to keep the locals pointer in A4 rather than the user
\          MSD003 variable, LOCBASE.
\ 19980803 MSD002 Remove the INCLUDE of LOCALCOM; this is now done in the
\          MSD002 control files to facilitate having "buildkit" and "customer"
\          MSD002 versions of the directory layout.  (All the file inclusions
\          MSD002 are now done in one place - the control file.)
\ 19980427 MSD001 Create a file containing the common, high-level, locals code
\          MSD001 and *use* it.  Also, remove the code that put LOCALS| into
\          MSD001 the ENVIRONMENT vocabulary.

((
        Copyright (c) 1988-1999
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 2380 631441
        fax: +44 2380 339691
        net: mpe@mpeltd.demon.co.uk
             tech-support@mpeltd.demon.co.uk
        web: www.mpeltd.demon.co.uk
))

only forth definitions
hex

\ ------------------------------------------------------------------------------
\       runtime primitives
\ ------------------------------------------------------------------------------

internal

CODE LV!  (  n  -- ; store local variable [offset in-line]  )
  (a7)+ a1 movea,                                       \ get inline address
  (a1)+ d0 move,                                        \ get offset (in-line)
  d7 0 d(a4, d0.l) move,                                \ & write data to r:stack from TOS \ MSD003
  (a6)+ d7 move,                                        \ pop TOS
  (a1) jmp,
END-CODE

CODE LV@  (  --  n ; read local variable [offset in-line]  )
  (a7)+ a1 movea,                                       \ get inline address
  (a1)+ d0 move,                                        \ get offset (in-line)
  a4 a0 movea,                                          \ get current local base \ MSD003
  d0 a0 adda,                                           \ now add offset
  d7 -(a6) move,                                        \ push TOS
  (a0) d7 move,                                         \ & read data from r:stack into TOS
  (a1) jmp,
END-CODE

CODE LV  (  --  a-addr ; read local variable address [offset in-line]  )
  (a7)+ a1 movea,                                       \ get inline address
  (a1)+ d0 move,                                        \ get offset (in-line)
  a4 a0 movea,                                          \ get current local base \ MSD003
  d0 a0 adda,                                           \ now add offset
  d7 -(a6) move,                                        \ push TOS
  a0 d7 move,                                           \ & return address into TOS
  (a1) jmp,
END-CODE

CODE MAKELVS  \ -- ; make space for local variables 
              \ #args (cells), #locals (cells) in-line
              \ Frame structure is as OTA spec, vol1 3.2.5
              \ arguments +ve offset, locals -ve offset
\ allocate a frame for the arguments
  (a7)+ a0 movea,                       \ save RTS address
  a7 a1 movea,                          \ save current RSP

  d0 d0 sub,
  (a0)+ d0 w. move,                     \ get #args
  # 2 d0 asl,                           \ convert cells to bytes
  d0 a7 suba,                           \ now add offset

  a1 -(a7) move,                        \ save previous RSP             \ SFP004
  a4 -(a7) move,                        \ save current local base       \ SFP004
  a7 a4 movea,                          \ current stack = new local base \ MSD003

\ pop the arguments into the frame; D0=#bytes, A6=FP
  d0 d0 move,                           \ anything to do?
  makelvs3 beq,                         \ no, skip
  8 d(a7) a1 lea,                       \ TOS at FP+8
  d7 (a1)+ move,                        \ deal with cached TOS
l: makelvs1
  # 4 d0 subq,                          \ step down
  makelvs2 beq,                         \ get out when done
  (a6)+ (a1)+ move,                     \ pop next parameter
  makelvs1 bra,
l: makelvs2
  (a6)+ d7 move,                        \ restore TOS
l: makelvs3

\ reserve local variable space
\  d0 d0 sub,                           \ d0 is already 0
  (a0)+ d0 w. move,                     \ get #args
  # 2 d0 asl,                           \ convert cells to bytes
  d0 a7 suba,                           \ now add offset

  (a0) jmp,
END-CODE

CODE RELLVS     \ -- ; drop local variables
  a4 a0 l. movea,                       \ get current local base        \ SFP004
  (a0)+ a4 l. movea,                    \ restore frame pointer         \ SFP004
  (a0) a7 l. movea,                     \ restore return stack pointer
  next,   
END-CODE

external

