\ 68K Version 6.1 XC, Min68K.fth, Code words

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20031216 SFP008 DOCGENned.
20000710 SFP007 Converted to v6.1 model
19980416 MSD006 Add ColdFire stuff.  (*Not* flagged.)
19980311 MSD005 Added EI and DI to make the 68K word-set compatible with
         MSD005 other processors.
19980309 SFP004 Removed comparisons, (OF), logicals - now code generated
19980307 SFP003 Removed DOCREATE, DODOES, (LOOP), (+LOOP)
19980305 MSD002 Added SAVE-INT and RESTORE-INT since we now include the
         MSD002 *entire* multi-tasking system in chip Forth.
19980304 MSD001 Added (C") and (S") from ROM\COMMON\KERNEL.FTH.
))


\ =========
\ *! min68k
\ *T Minimal Umbilical code definitions
\ =========
\ *P The file 68K\MIN68K.FTH contains the minimum code definitions
\ ** required to support Umbilical Forth. If additional definitions
\ ** are required, they may be copied to a new file from 68K\CODE68K.FTH
\ ** or COMMON\KERNEL62.FTH.


\ ***************
\ *S Flow of control
\ ***************

CODE (DO)	\ limit index --
\ *G The run time action of DO compiled on the target. 
  (A6)+ D1 MOVE,                                        \ get limit
L: PDO                                                  \
  (a7)+ a0 movea,                                       \ get BRANCH address
  (A0) -(A7) MOVE,   $80000000 # D1 ADD,                \ push LEAVE addr on ret. stk
  D1 -(A7) MOVE,   D1 D7 SUB,   D7 -(A7) MOVE,          \ then also limit, index
  (a6)+ d7 move,                                        \ update TOS
  4 # a0 addq,  (a0) jmp,                               \ continue
END-CODE

CODE (?DO)	\ limit index --
\ *G The run time action of ?DO compiled on the target. 
  (A6)+ D1 MOVE,   D1 D7 CMP,   pdo bne,                \ take DO ?
  (a6)+ d7 move,                                        \ update TOS
  (a7)+ a0 movea,                                       \ get BRANCH addr
  (a0) a1 movea,                                        \ and take LEAVE branch
  (a1) jmp,
END-CODE

CODE EXECUTE	\ xt --
\ *G Execute the code described by the XT. This is a Forth equivalent
\ ** to an assembler JSR/CALL instruction.
  d7 a0 movea,                          \ move CFA
  (a6)+ d7 move,                        \ get new TOS
  (a0) jmp,                             \ execute CFA
END-CODE


\ **************************
\ *S Stack operations and maths
\ **************************

(( Optimiser does this now
CODE LIT  	\ -- x 
  d7 -(a6) move,                        \ save TOS
  (a7)+ a0 movea,                       \ get new one
  (a0)+ d7 move,                         
  (a0) jmp,                             \ JUMP to it
END-CODE

CODE S>D  	\ n -- d 
  d7 -(a6) move,   D7 smi,
  D7 W. EXT,   D7 L. EXT,
  next,
END-CODE
))

Code Noop	\ -- ; used by multi-tasker
\ *G A NOOP, null instruction.                                          )
  Next,
End-Code

CODE MIN	\ n1 n2 -- n'
\ *G Given two data stack items preserve only the smaller.
  (A6)+ D0 MOVE,  D0 D7 CMP,  MINX BLT,	\ tos-nos < 0 == tos < nos
  D0 D7 MOVE,
L: MINX
  next,
END-CODE

CODE MAX	\ n1 n2 -- n1|n2
\ *G Given two data stack items preserve only the smaller.
  (A6)+ D0 MOVE,  D0 D7 CMP,  MAXX BGT,	\ tos-nos > 0 == tos > nos
  D0 D7 MOVE,
L: MAXX
  next,
END-CODE

CODE WITHIN?	\ n1 n2 n3 -- flag
\ *G Return TRUE if N1 is within the range N2..N3.
\ ** This word uses signed arithmetic.
  d7 d0 move,                           \ d2=x, d1=a, d0=b
  (A6)+ D1 MOVE,
  (A6)+ D2 MOVE,
  d7 CLR,
  D1 D2 CMP,   WITH1 BLT,               \ x-a
  D0 D2 CMP,   WITH1 BGT,               \ x-b
  1 # d7 SUBQ,
L: WITH1
  next,
END-CODE

CODE DNEGATE  	\ d1 -- d2 
\ *G Negate a double number.
L: DNEG1
  D2 CLR,   (A6) D1 MOVE,                               \ d in d7:d1
  D7 NOT,   D1 NOT,   1 # D1 ADDQ,   D2 D7 ADDX,        \                       ***JL001***
  D1 (A6) MOVE,   
  next,
END-CODE

CODE ?NEGATE	\ n1 flag -- n1|n2 
\ *G If flag is negative, then negate n1.
  d7 tst,
  mi, if,  (a6)+ d7 move,   d7 neg,   next,   endif,
  (a6)+ d7 move,   next,
END-CODE

CODE ?DNEGATE	\ d1 flag -- d1|d2 
\ *G If flag is negative, then negate d1.
  d7 tst,
  mi, if,  (a6)+ d7 move,   dneg1 bra,  endif,
  (a6)+ d7 move,   next,
END-CODE

CODE D+		\ d1 d2 -- d3 
\ *G Add two double precision integers.
  (A6)+ D1 MOVE,   (A6)+ D2 MOVE,       \ d7:d1 + d2:(a7)
  (a6)+ D1 ADD,   D2 D7 ADDX,           \ -> d7:d1
  D1 -(A6) MOVE,
  next,
END-CODE

CODE D-		\ d1 d2 -- d3 
\ *G Subtract two double precision integers. D3=D1-D2.
  (A6)+ D0 move,
  (A6)+ D1 move,
  D0 (A6) sub,
  D7 D1 subx,
  D1 D7 move,
  next,
END-CODE

(( Optimiser does this now
Code Abs        \ d -- u
  d7 tst,
  mi, if, d7 neg, endif,
  next,
End-code
))


\ *******************
\ *S Multiply and divide
\ *******************
\ *P Different multiply and divide routines are compiled
\ ** according to the setting of equate CPU32? which should
\ ** be set non-zero for CPU32 CPUs such as the 68332 which have
\ ** enhanced multiply and divide instructions.

cpu32? [if]                                                                            

CODE UM*        \ u1 u2 -- ud
\ *G Perform unsigned-multiply between two numbers and return double
\ ** result.
  (a6) d0: d7 l. mulu,                  \ perform multiply
  d7 (a6) l. move,   d0 d7 l. move,     \ order the stack
  next,   end-code

CODE *          \ n1 n2 -- n3
\ *G Standard signed multiply. N3 = n1 * n2.
  (a6)+ d7 l. muls,                     \ perform multiply
  next,   end-code

CODE M*         \ n1 n2 -- d3
\ *G Signed multiply yielding double result.
  (a6) d0: d7 l. muls,                  \ perform multiply
  d7 (a6) l. move,   d0 d7 l. move,     \ order the stack
  next,   end-code

[else]

CODE UM*        \ u1 u2 -- ud ; MUST preserve D5
  d7 d6 move,
  # $ffff0000 d6 andi,                  \ use fast version if top 16 bits 0
  eq, if,
    (a6) w. tst,  um*fast beq,          \ are both 0?
  endif,

  d7 -(a6) move,                                \ easier in memory
  D4 CLR,                                       \ used for fast 0
  6 D(A6) D0 W. MOVE,   2 D(A6) D0 W. MULU,     \ d0 = u1.l * u2.l              
  4 D(A6) D1 W. MOVE,   (A6)    D1 W. MULU,     \ d1 = u1.h * u2.h              
  4 D(A6) D2 W. MOVE,   2 D(A6) D2 W. MULU,     \ d2 = u1.h * u2.l              
  6 D(A6) D3 W. MOVE,   (A6)    D3 W. MULU,     \ d3 = u1.l * u2.h              
  D1 (A6) MOVE,   D0 4 D(A6) MOVE,
  (A6) D1 W. MOVE,   2 D(A6) D0 L. MOVE,
  D2 D0 L. ADD,   D4 D1 W. ADDX,                \ used as ADDX # 0
  D3 D0 L. ADD,   D4 D1 W. ADDX,
  D0 2 D(A6) L. MOVE,   D1 (A6) W. MOVE,
  (a6)+ d7 move,
  mul-exit bra,

l: um*fast
  2 D(A6) D7 W. MULU,                           \ multiply low words            
  d7 (a6) move,
  # 0 d7 moveq,                                 \ clear high word

l: mul-exit
  next,
END-CODE

: *             \ n1 n2 -- n3
  um* drop
;

CODE M*         \ n1 n2 -- d ; relies on UM* leaving D5 alone
  d7 d5 l. move,
  (a6) d1 move,  d1 d5 eor,             \ form sign of result
  d7 l. tst,                            \ form |n2|
  mi, if,  d7 l. neg,  endif,
  d1 l. tst,                            \ form |n1|
  mi, if,  (a6) neg,  endif,
  ' um* w. bsr,
  d5 l. tst,
  mi, if,
    D2 CLR,   (A6) D1 MOVE,             \ d in d7:d1
    D7 NOT,   D1 NOT,
    1 # D1 ADDQ,   D2 D7 ADDX,
    D1 (A6) MOVE,
  endif,
  next,
END-CODE

[then]


cpu32? [if]                                                                            

CODE UM/MOD   \ ud u -- urem uquot                                              
\ *G Perform unsigned division of double number UD by single number U
\ ** and return remainder and quotient.
  (A6)+ D0 MOVE,                        \ d7=divisor                              
  (A6)+ D1 MOVE,                        \ d0:d1=dividend                          
  d7 d0: d1 l. divu,                    \ divide
  trapv,                                \ overflow check
  d0 -(a6) l. move,                     \ push remainder                          
  d1 d7 l. move,                        \ copy quotient                           
  next,                                                                         
end-code                                                                        

CODE FM/MOD     \ d1 n2 -- rem quot ; symmetric division
\ *G Perform a signed division of double number D1 by single number N2
\ ** and return remainder and quotient using floored division. See the
\ ** ANS Forth specification for more details of floored division.
  (a6)+ d0 move,
  (a6)+ d1 move,                        \ d0:d1=dividend
L: FM/MOD1
  d0 d3 move,
  d7 d3 eor,                            \ d3=sign of quotient
  d7 d4 move,                           \ d4=sign of divisor
  mi, if,  d7 neg,  endif,              \ form |divisor|
  d0 tst,                               \ form |dividend|
  mi, if,
    # 0 d5 moveq,                       \ d5=0 for fast addition
    d0 not,
    d1 not,                             \ invert dividend
    # 1 d1 addq,
    d5 d0 addx,                         \ and add 1
  endif,

  d7 d0: d1 l. divu,                    \ perform division
  trapv,

l: fm/mod2
  d4 tst,                               \ remainder takes sign of divisor
  mi, if,  d0 neg,  endif,
  d3 tst,                               \ set sign of quotient
  mi, if,
    d1 neg,
    d0 tst,                             \ quot -> -ve, remainder non zero?
    ne, if,
      # 1 d1 subq,                      \ quot := quot - 1
      d0 d4 sub,                        \ rem := divisor - rem
      d4 d0 move,
    endif,
  endif,
  d0 -(a6) move,                        \ return remainder
  d1 d7 move,                           \ return quotient
  next,   
END-CODE

CODE SM/REM     \ d1 n2 -- rem quot ; symmetric division
\ *G Perform a signed division of double number D1 by single number N2
\ ** and return remainder and quotient using symmetric (normal) division.
  (a6)+ d0 move,
  (a6)+ d1 move,                        \ d0:d1=dividend
  d7 d0: d1 l. divs,                    \ divide
  trapv,
  d0 -(a6) move,                        \ return remainder
  d1 d7 move,                           \ return quotient
  next,   
END-CODE

code /mod       \ n1 n2 -- rem quot ; 6.1.0240
\ *G Signed division of N1 by N2 single-precision yielding remainder
\ ** and quotient.
  (a6)+ d1 move,                        \ d1=dividend
  d7 d0: d1 l. divsl,                   \ divide
  trapv,
  d0 -(a6) move,                        \ return remainder
  d1 d7 move,                           \ return quotient
  next,   
end-code

code /          \ n1 n2 -- quot ; 6.1.0230
\ *G Standard signed division operator. n3 = n1/n2.
  (a6)+ d1 move,                        \ d1=dividend
  d7 d0: d1 l. divsl,                   \ divide
  trapv,
  d1 d7 move,                           \ return quotient
  next,   
end-code

code mod        \ n1 n2 -- rem ; 6.1.1890
\ *G Return remainder of division of N1 by N2. n3 = n1 mod n2.
  (a6)+ d1 move,                        \ d1=dividend
  d7 d0: d1 l. divsl,                   \ divide
  trapv,
  d0 d7 move,                           \ return remainder
  next,   
end-code

[else]

asmcode
l: udiv64/32	\ d0:d1 / d7 ; 64/32 unsigned divide -> d1=quot, d0=rem
		\ N.B. D3 must be preserved
  d0 d7 l. cmp,   udiv64/32-oflo bls,   \ check for overflow                      \ MSD011
  
  d3 -(a7) l. move,                     \ preserve D3

  d0 l. tst,                            \ can use chip instruction if d0=0, d7.h=0
  udiv64/32-slow w. bne,
  d7 d3 l. move,
  # $FFFF0000 d3 l. andi,
  udiv64/32-slow w. bne,
  d1 d3 l. move,			\ check for overflow d1:h d7.l
  d3 swap,
  d3 d7 w. cmp,   udiv64/32-fast bhi,

l: udiv64/32-slow
  $20 # d2 moveq,                       \ set loop counter
  begin,
    d1 d1 l. add,  d0 d0 l. addx,	\ 64 bit left shift
    d3 d3 l. subx,			\ save carry flag
    d7 d0 l. sub,			\ trial subtraction, carry clear?
    cc, if,                             \ y:
      1 # d1 l. addq,			\   increment quotient
    else,                               \ n:
      d3 d3 l. or,                      \   carry from shift set?
      ne, if,                           \   y:
        # 1 d1 l. addq,                 \     increment quotient
      else,                             \   n:
        d7 d0 l. add,                   \     undo subtraction
      endif,
    endif,
    1 # d2 l. subq,
  eq, until,

  (a7)+ d3 l. move,                     \ restore D3
  rts,

l: udiv64/32-fast
  d7 d1 w. divu,                        \ machine division
  d1 d0 l. move,                        \ copy result
  # $FFFF d1 l. andi,                   \ extract quotient
  # 8 d0 l. lsr,  # 8 d0 l. lsr,        \ extract remainder
  
  (a7)+ d3 l. move,                     \ restore D3
  rts,

l: udiv64/32-oflo
  d0 l. clr,                            \ set remainder
  # $FFFFFFFF d1 l. move,               \ set quotient
  rts,
end-code

CODE UM/MOD     \ ud u -- urem uquot
  (A6)+ D0 MOVE,                                      \ d7=divisor
  (A6)+ D1 MOVE,                                      \ d0:d1=dividend
  UDIV64/32 BSR,
  D0 -(A6) MOVE,                                      \ remainder
  D1 d7 MOVE,                                         \ quotient
  next,
END-CODE

CODE FM/MOD     \ d1 n2 -- rem quot ; symmetric division
  (a6)+ d0 move,
  (a6)+ d1 move,                        \ d0:d1=dividend
L: FM/MOD1
  d0 d3 move,
  d7 d3 eor,                            \ d3=sign of quotient
  d7 d4 move,                           \ d4=sign of divisor
  mi, if,  d7 neg,  endif,              \ form |divisor|
  d0 tst,                               \ form |dividend|
  mi, if,
    # 0 d5 moveq,                       \ d5=0 for fast addition
    d0 not,
    d1 not,                             \ invert dividend
    # 1 d1 addq,
    d5 d0 addx,                         \ and add 1
  endif,
  UDIV64/32 w. bsr,                     \ call divide; d0=rem, d1=quot
  d4 tst,                               \ remainder takes sign of divisor
  mi, if,  d0 neg,  endif,
  d3 tst,                               \ set sign of quotient
  mi, if,
    d1 neg,
    d0 tst,                             \ quot -> -ve, remainder non zero?
    ne, if,
      # 1 d1 subq,                      \ quot := quot - 1
      d0 d4 sub,                        \ rem := divisor - rem
      d4 d0 move,
    endif,
  endif,
  d0 -(a6) move,                        \ return remainder
  d1 d7 move,                           \ return quotient
  next,   
END-CODE

CODE SM/REM     \ d1 n2 -- rem quot ; symmetric division
  (a6)+ d0 move,
  (a6)+ d1 move,                        \ d0:d1=dividend
L: sm/rem1
  d0 d3 move,
  d7 d3 eor,                            \ d3=sign of quotient
  d0 d4 move,                           \ d4=sign of remainder/dividend
  d7 tst,
  mi, if,  d7 neg,  endif,              \ form |divisor|
  d0 tst,                               \ form |dividend|
  mi, if,
    # 0 d5 moveq,                       \ d5=0 for fast addition
    d0 not,
    d1 not,                             \ invert dividend
    # 1 d1 addq,
    d5 d0 addx,                         \ and add 1
  endif,
  UDIV64/32 w. bsr,                     \ call divide; d0=rem, d1=quot
  d4 tst,                               \ remainder takes sign of dividend
  mi, if,  d0 neg,  endif,
  d3 tst,                               \ set sign of quotient
  mi, if,  d1 neg,  endif,
  d0 -(a6) move,                        \ return remainder
  d1 d7 move,                           \ return quotient
  next,   
END-CODE

: /mod          \ n1 n2 -- rem quot ; 6.1.0240
  >r s>d r> sm/rem
;

: /             \ n1 n2 -- n3
  >r s>d r> sm/rem nip
;

: MOD           \ n1 n2 -- n3
  >r s>d r> sm/rem drop
;

[endif]

: */MOD         \ n1 n2 n3 -- rem quot
\ *G Multiply n1 by n2 to give a double precision result, and then
\ ** divide it by n3 returning the remainder and quotient. The point
\ ** of this operation is to avoid loss of precision.
  >r m* r> sm/rem
;

: */            \ n1 n2 n3 -- n4
\ *G Multiply n1 by n2 to give a double precision result, and then
\ ** divide it by n3 returning the quotient. The point
\ ** of this operation is to avoid loss of precision.
  >r m* r> sm/rem nip
;

: M/            \ d n1 -- n2
\ *G Signed divide of a double by a single integer.
  sm/rem nip
;

: MU/MOD        \ d n  --  rem d#quot
\ *G Perform an unsigned divide of a double by a single, returning
\ ** a single remainder and a double quotient.
  >r  0  r@  um/mod  r>  swap  >r  um/mod  r>
;


\ *********************
\ *S Stack manipulation
\ *********************

CODE SP@  	\ -- x 
\ *G Get the current address value of the data-stack pointer.
   d7 -(a6) move,   a6 d7 move,   next,
END-CODE

CODE SP!	\ x --
\ *G Set the current address value of the data-stack pointer.
  d7 a6 movea,  (a6)+ d7 move,  next,
END-CODE

CODE RP@  	\ -- x 
\ *G Get the current address value of the return-stack pointer.
  (a7)+ a0 movea,
  d7 -(a6) move,   a7 d7 move,
  (a0) jmp,
END-CODE

CODE RP!  	\ x --
\ *G Set the current address value of the return-stack pointer.
  (a7)+ a0 movea,
  d7 a7 movea,   (a6)+ d7 move,
  (a0) jmp,
END-CODE

(( optimiser does all this now
CODE 2OVER  	\ x1 x2 x3 x4 -- x1 x2 x3 x4 x1 x2 
  d7 -(a6) move,                        \ put TOS into deep stack
  $0C d(a6) d0 move,   $08 d(a6) d7 move,
  d0 -(a6) move,   next,
END-CODE

CODE DROP  	\ x --
  (a6)+ d7 move,   next,
END-CODE

CODE 2DROP  	\ x1 x2 --
  # 4 a6 addq,   (a6)+ d7 move,   next,
END-CODE

CODE 2SWAP  	\ x1 x2 x3 x4 -- x3 x4 x1 x2 
  d7 D0 MOVE,   (A6) D1 MOVE,           \ save d0=n4 d1=n3
  4 D(A6) d7 MOVE,   8 D(A6) (A6) MOVE, \ move n1 n2
  D0 4 D(A6) MOVE,   D1 8 D(A6) MOVE,   \ move n4 n3
  next,
END-CODE

CODE ?DUP  	\ x -- | x 
  d7 tst,
  ne, if,  d7 -(a6) move,  endif,
  next,
END-CODE

CODE 2DUP  	\ x1 x2 -- x1 x2 x1 x2 
  (a6) d0 move,                         \ d0=n1 d7=n2
  d7 -(a6) move,   d0 -(a6) move,
  next,
END-CODE
))

CODE ROLL  	\ xu xu-1 .. x0 u -- xu-1 .. x0 xu 
\ *G Rotate the order of the top N stack items by one place such that
\ ** the current top of stack becomes the second item and the Nth item
\ ** becomes TOS. See also ROT.
  D7 D0 MOVE,   rollx bmi,  rollx beq,
  2 # D0 ASL,   0 D(A6, D0.L) D7 MOVE,
L: ROLL1
  Is-ColdFire? [if]
    -4 d(a6, d0.l) d2 move,
    d2 0 d(a6, d0.l) move,
  [else]                  
    -4 D(A6, D0.L) 0 D(A6, D0.L) MOVE,
  [then]                  
  4 # D0 SUBQ,   ROLL1 BNE,

  4 # A6 ADDQ,
  D7 D0 MOVE,
  next,

L: ROLLX
  (a6)+ d7 move,   next,
END-CODE

CODE ON  	\ a-addr --
\ *G Given the address of a CELL this will set its contents to TRUE (-1).
  d7 A0 MOVEA,   -1 # (a0) MOVE,
  (a6)+ d7 move,   next,
END-CODE

CODE OFF  	\ a-addr --
\ *G Given the address of a CELL this will set its contents to FALSE (0).
  d7 A0 MOVEA,  (A0) CLR,
  (a6)+ d7 move,   next,
END-CODE


\ ******************************
\ *S string and memory operators
\ ******************************

CODE 2@  	\ a-addr -- x1 x2 
\ *G Fetch and return the two CELLS from memory ADDR and ADDR+sizeof(CELL).
\ ** The cell at the lower address is on the top of the stack.
  d7 a0 movea,
  4 d(a0) -(a6) move,   (a0) d7 move,
  next,
END-CODE

CODE 2!  	\ x1 x2 a-addr --
\ *G Store the two CELLS x1 and x2 at memory ADDR.
\ ** X2 is stored at ADDR and X1 is stored at ADDR+CELL.
  d7 a0 movea,
  (a6)+ (a0) move,   (a6)+ 4 d(a0) move,
  (a6)+ d7 move,   next,
END-CODE

CODE c+!        \ b addr --
\ *G Add N to the character (byte) at memory address ADDR.
  d7 a0 movea,   (a6)+ d0 move,
  Is-ColdFire? [if]
    # 0 d1 moveq,
    (a0) d1 b. move,
    d0 d1 add,
    d1 (a0) b. move,
  [else]
    d0 (a0) b. add,
  [then]
  (a6)+ d7 move,   next,
end-code

CODE COUNT  	\ c-addr1 -- c-addr2' u 
\ *G Given the address of a counted string in memory this word will
\ ** return the address of the first character and the length in
\ ** characters of the string.
  D7 A0 MOVEA,                          \ need an address reg.
  1 # D7 ADDQ,   d7 -(a6) move,         \ return ADDR'
  D7 CLR,   (A0) D7 B. MOVE,            \ get length
  next,
END-CODE

CODE CMOVE  	\ c-addr1 c-addr2 u --
\ *G Copy U bytes of memory forwards from C-ADDR1 to C-ADDR2.
  (A6)+ A0 MOVEA,
  (A6)+ A1 MOVEA,
  D7 TST,   CMOV2 BEQ,
L: CMOV1
  (A1)+ (A0)+ B. MOVE,   1 # D7 SUBQ,  CMOV1 BNE,
L: CMOV2
  (a6)+ d7 move,   next,
END-CODE

CODE CMOVE>  	\ c-addr1 c-addr2 u --
\ *G As CMOVE but working in the opposite direction,
\ ** copying the last character in the string first.
  (A6)+ A0 MOVEA,   D7 A0 ADDA,
  (A6)+ A1 MOVEA,   D7 A1 ADDA,
  D7 TST,   CMV>2 BEQ,
L: CMV>1
  -(A1) -(A0) B. MOVE,   1 # D7 SUBQ,  CMV>1 BNE,
L: CMV>2
  (a6)+ d7 move,   next,
END-CODE

\ Fill is used by multi-tasker
CODE FILL  	\ c-addr u char --
\ *G Fill U bytes of memory starting at C-ADDR with the byte information
\ ** specified as CHAR.
  (A6)+ D1 MOVE,   (A6)+ A0 MOVEA,      \ d7=char, d1=count, a0=addr
  D1 TST,   FIL2 BEQ,
L: FIL1
  D7 (A0)+ B. MOVE,   # 1 d1 subq,   fil1 bne,
L: FIL2
  (a6)+ d7 move,  next,
END-CODE

CODE (")  	\ -- a-addr ; return address of string, skip over it 
\ *G Return the address of a counted string that is inline after the 
\ ** CALLING word, and adjust the CALLING word's return address to 
\ ** step over the inline string. See the definition of (.") for
\ ** an example.
  (a7)+ a0 movea,			\ get RTS address
  d7 -(a6) move,			\ save TOS
  (A7) A2 MOVEA,   A2 d7 MOVE,		\ save address
  D0 CLR,   (A2) D0 B. MOVE,		\ get count byte
  2 # D0 ADDQ,
  Is-ColdFire? [if]
    $FFFE # d0 andi,                    \ 1 for c.b. 1 to force even \ MSD006
  [else]                                
    $FFFE # D0 W. ANDI,	                \ 1 for c.b. 1 to force even
  [then]                                
  D0 (A7) ADD,				\ update second level RTS address
  (a0) jmp,				\ jump to first level RTS address
END-CODE

: (C")		\ -- c-addr                     
\ *G The run time action compiled by C".
  (")                                   
;                                       
                                        
: (S")		\ -- c-addr u                   
\ *G The run time action compiled by S".
  (") count                             
;                                       


\ ************************************
\ *S Umbilical versions of defining words
\ ************************************

asmcode
chere is-action-of constant
\ *G The runtime code for a CONSTANT.
chere is-action-of variable
\ *G The runtime code for a VARIABLE.
  d7 -(a6) move,                        \ save old TOS
  (a7)+ a0 movea,                       \ get PFA
  (a0) d7 move,                         \ get constant value
  next,
END-CODE

asmcode
chere is-action-of user
\ *G The runtime action of a USER variable.
  d7 -(a6) l. move,                     \ save old TOS
  (a7)+ a0 l. movea,                    \ get PFA
  (a0) d7 l. move,                      \ get user value
  a5 d7 l. add,				\ add user pointer to user value
  next,
end-code

: CRASH		\ -- ; used as action of DEFER 
\ *G The default action of a DEFERed word. A NOOP.
;

asmcode
chere is-action-of DEFER	\ Comp: "<spaces>name" -- ; Run: i*x -- j*x 
\ *G The runtime action of a DEFERred word.
  (a7)+ a1 movea,
  (a1) a0 movea,
  (a0) a1 movea,
  (a1) jmp,
end-code


\ ======
\ *> ###
\ ======

decimal

