\ 68000 assembler macros
\
\ Released for use with the MPE Forth Cross Compiler by:
\
\ MicroProcessor Engineering
\ 133 Hill Lane
\ Southampton SO15 5AF
\ England
\
\ tel: (+44) 2380 631441   (international)
\           02380 631441   (domestic)
\
\ email: mpe@mpeltd.demon.co.uk
\
\

\ JLSTC:
\   Changed NEXT, macro to RTS,

only forth  also c-c  also assembler
also asm-access definitions

: NEXT,		\ --
  rts,
;

: dc.b		\ b -- ; compile byte (8-bit) value
  c,c(t)  ;

: dc.w		\ w -- ; compile word (16-bit) value
  w,c(t)  ;

: dc.l		\ l -- ; compile long word (32-bit) value
  l,c(t)  ;


  \ Preserve old versions of definitions
: AND,,		AND, ;
: EOR,,		EOR, ;
: OR,,		OR, ;
: ADD,,		ADD, ;
: SUB,,		SUB, ;
: MOVE,,	MOVE, ;
: CMP,,		CMP, ;

: MOVE,		\ inteligent move
  AR2? if				\ check for MOVEA,
    movea,  exit
  endif
  #?  DR2? AND IF			\ check for MOVEQ,
    DUP SHORT? IF
      MOVEQ, EXIT
    ENDIF
  ENDIF
  MOVE,					\ default
;

: CMP,		\ handle (An)+ (An)+ CMP , use CMPM 
  AR1)+? AR2)+? AND IF
    CMPM,  exit
  THEN
  AR2?  byte? 0= and  if
    cmpa,  exit
  then
  #?  dr2? not and if
    cmpi,  exit
  then
  CMP,
;

only forth  also c-c  also assembler definitions

: AUTO-I	\ -- ; <standard-form> <immediate-form> <newname> )
  [ forth ] '  '
  CREATE
    , , 
  DOES>			\ executes <standard-form> or <immediate-form> )
    [ only forth  also c-c  also assembler ]
    #? 0=
    IF  CELL+   ENDIF
    @ EXECUTE
; 

only forth  also c-c  also assembler definitions

: AUTO-QIA	\ -- ; <standard> <quick> <immediate> <address> <newname>
  [ forth ]   '  '  '  '
    CREATE  , , , ,
  DOES>		\ executes required form, 0=Addr, 1=Imm, 2=Quick, 3=Gen 
  [ only forth  also c-c  also assembler ]
  #? IF					\ immediate 
    OVER 1 8 WITHIN?  			\ ok for Quick?
    IF  2  ELSE  1  ENDIF		\ select Q or I form
  ELSE
    AR2? IF  0  ELSE  3  ENDIF		\ use XXXA form ?
  ENDIF
  CELLS+ @ EXECUTE
; 

also asm-access definitions
  AUTO-I AND, ANDI, AND,
  AUTO-I OR, ORI, OR,
  AUTO-I EOR, EORI, EOR,

  AUTO-QIA ADD, ADDQ, ADDI, ADDA, ADD,
  AUTO-QIA SUB, SUBQ, SUBI, SUBA, SUB,
  
only forth definitions

