\ 68332 special function registers

((
        Copyright (c) 1988-1998
        MicroProcessor Engineering
        133 Hill Lane
        Southampton SO15 5AF
        England

        tel: +44 2380 631441
        fax: +44 2380 339691
        net: mpe@mpeltd.demon.co.uk
             tech-support@mpeltd.demon.co.uk
        web: www.mpeltd.demon.co.uk
))

\ SIM - System Integration Module

$0FFFFFA00 equ MCR   \ Module Configuration Register

\ offsets from MCR:

$004 equ &SYNCR	    \ Clock SyNthesiser Control Register
$007 equ &RSR	    \ Reset Status Register
$020 equ &SYPCR	    \ SYstem Protection Control Register
$022 equ &PICR	    \ Periodic Interrupt Control Register
$024 equ &PITR	    \ Periodic Interrupt Timimg Register
$044 equ &CSPAR0     \ Chip Select Pin Assignment Register 0
$048 equ &CSBARBT    \ Chip Select BAse Register BooT
$04A equ &CSORBT     \ Chip Select Option Register BooT

$0FFFFFA4C equ CSBAR0	\ Chip Select BAse Address Register 0
			\ Chip selects 1-10 base addresses follow.
\ RAM module

$0FFFFFB00 equ RAMMCR	\ RAM Module Configuration Register
$0FFFFF000 equ SRAM     \ Select this as the address of standby ram.
	                \ N.B. Must be on a 2K boundary, & not overlapping
			\ anything in the SIM - see 68332 manual 6-5.

\ offsets from RAMMCR
$04 equ &RAMBAR		\ RAm Module Base Address Register

\ Queued serial module

$0FFFFFC00 equ QMCR   \ queued serial Module Configuration Register

\ offsets from QMCR:
$04 equ &QILR	 \ queued serial module interrupt level register
$05 equ &QIVR	 \ queued serial module interrupt vector register
$08 equ &SCCR0	 \ serial comms control register 0
$0A equ &SCCR1	 \ serial comms control register 1
$0C equ &SCSR	 \ serial comms status register
$0E equ &SCDR	 \ serial comms data register (Tx & Rx)

\ TPU - Timer Processor Unit

  $0FFFFFE00   equ TMCR		\ TPU Module Configuration Register
  TMCR	 $08 + equ TICR		\ TPU Interrupt Configuration register
  TMCR	 $0A + equ CIER		\ Channel Interrupt Enable Register
  TMCR	 $0C + equ CFSR0 	\ Channel Function Select Register 0
  TMCR	$014 + equ HSQR0 	\ Host Sequence Register 0
  TMCR	$018 + equ HSRR0 	\ Host Service Request Register 0
  TMCR	$01A + equ HSRR1
  TMCR	$01C + equ CPR0		\ Channel Priority Register 0
  TMCR	$020 + equ CISR		\ Channel Interrupt Status Register
  TMCR $0100 + equ CH0-P0	\ Channel 0 Parameter 0
  TMCR $0102 + equ CH0-P1	\ etc.
  TMCR $0104 + equ CH0-P2
  TMCR $0106 + equ CH0-P3
  TMCR $0108 + equ CH0-P4
  TMCR $010A + equ CH0-P5
  TMCR $010C + equ CH0-P6
  TMCR $01FC + equ TCR2_VALUE

  CH0-P2 $40 + equ CURRENT_POSITION     \ current stepper motor position
  CH0-P3 $40 + equ DESIRED_POSITION     \ target stepper motor position

