\ MPE PowerForth/32 software floating point package

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE

20000703 SFP003 Converted to v6.1 code. Adopted coded version of NORM
                which will be used by the common code if provided.
19981029 MSD002 Delete all of the *common* FP stuff as it is now in the
         MSD002 COMMON sub-directory.  Also, removed reams of commented-out
         MSD002 code.  (Neither is flagged.)
19980409 MSD001 Add COLDFIRE-specific code.


32-bit mantissa and 32-bit exponent
))


\ ------------------------------------------------------------------------------
\ 68000 STC shift routines
\ ------------------------------------------------------------------------------

compiler
: <<1		\ n -- n<<1
  2*
;

: >>1           \ n -- n>>1
  u2/
;
target

code <-S	\ n1 carry-in-flag -- n2 carry-out-flag
  (a6)+ d1 l. move,			\ get n1
  d0 l. clr,				\ clear output flag
  # 1 d7 l. lsr,			\ put input flag in X bit
  d1 d1 l. addx,			\ shift n1 left with X, carry to X
  d0 d0 l. addx,			\ set carry out flag
  d1 -(a6) l. move,			\ stash n2
  d0 d7 l. move,			\ stash flag
  next,
end-code

code S->	\ n1 carry-in-flag -- n2 carry-out-flag
  (a6)+ d1 l. move,			\ get n1
  d0 l. clr,				\ clear output flag
  # 1 d7 l. andi,                       \ make flag 00000000 or 80000000
Is-ColdFire? [if]
  d7 d3 move,
  # 1 d3 andi,
  # 1 d7 lsr,
  # #31 d4 moveq,
  d4 d3 lsl,
  d1 d7 or,
[else]
  # 1 d7 l. ror,
[endif]
  # 1 d1 l. lsr,			\ shift n1 right, carry to X
  d0 d0 l. addx,			\ set carry out flag
  d7 d1 l. or,				\ add carry in to n1>>1
  d1 -(a6) l. move,			\ stash n2
  d0 d7 l. move,			\ stash flag
  next,
end-code

code d<<1	\ xd -- xd<<1
  (a6)+ d0 move,
  # 1 d0 l. lsl,                        \ shift low word left, dropped bit in carry
Is-ColdFire? [if]
  # 1 d7 l. lsl,                        \ rotate high word left bringing in carry at right 
  # 0 d1 move,
  d1 d7 addx,
[else]
  # 1 d7 l. roxl,                       \ rotate high word left bringing in carry at right
[endif]
  d0 -(a6) move,
  next,
end-code

code d>>1	\ xd -- xd>>1
  (a6)+ d0 move,
  # 1 d7 l. lsr,                        \ shift high word right, dropped bit in carry
Is-ColdFire? [if]
  # 1 d0 l. lsr,                        \ rotate low word right bringing in carry at left
  NC1 bcc,                              \ branch if carry clear
  # #31 d0 bset,                        \ set the top bit
l: NC1
[else]
  # 1 d0 l. roxr,                       \ rotate low word right bringing in carry at left
[then]
  d0 -(a6) move,
  next,
end-code

code D>>N	\ d m -- d>>m
  d7 d1 l. move,			\ preserve shift count
  (a6)+ d7 l. move,			\ fetch high word of double
  d1 d1 or,
  ne, if,
    (a6)+ d0 l. move,                   \ fetch low word of double
    # 1 d1 subq,                        \ always does at least one loop
l: D>>N-LOOP
    # 1 d7 l. lsr,                      \ shift high word right, dropped bit in carry
Is-ColdFire? [if]
    # 1 d0 lsr,                         \ rotate low word right bringing in carry at left
    NC2 bcc,
    # #31 d0 bset,
l: NC2
    # 1 d1 subq,                        \ do for number of shifts
    # -1 d0 cmp,
    D>>N-LOOP bne,
[else]
    # 1 d0 l. roxr,                     \ rotate low word right bringing in carry at left
    d1 D>>N-LOOP dbra,                  \ do for number of shifts
[then]
    d0 -(a6) l. move,                   \ put back low word of double
  endif,
  next,
end-code

CODE NORM	\ n exp -- fn ; normalise a 32bit word
  (a6) D0 L. MOVE,
  NE, IF,
    MI, IF,
      D0 L. NEG,			 \ get ABS value
    THEN,
    \ Test for unique value 8000.0000, max -ve number
    \ No +ve counterpart
    \ If still -ve leave mantisa & exponent alone
    PL,	IF,
      \ Use Decrement & branch for speed:
      \ As counter starts at -1 will not terminate until
      \ 65536 iterations
      \ If -ve on first loop will terminate with D1 = -1
      -1 # D1 L. MOVE,			\ initial exponent adjustment	
L: NORM_BEGIN,
         \ 1 # D7 L. SUB,		\ exp-1
 	1 # D0 L. LSL,			\ <<1
      D1 NORM_BEGIN, DBLT,		\ NORM_UNTIL,
      D1 D7 L. ADD,		 	\ Adjust exponent, rotated left 1 too many
      1 # D7 L. ADD,		 	\ exp+1
      1 # D0 L. LSR,		 	\ >>1
      (a6) L. TST,		 	\ Test original sign
      MI, IF,
        D0 L. NEG,		 	\ get ABS value
      THEN,
      D0 (a6) L. MOVE,
    THEN,
  ELSE,
    # 0  d7  l. moveq,
  THEN,
  NEXT,
END-CODE

