\ 68307 special function registers
\
\ Released for use with the MPE Forth Cross Compiler by:
\
\ MicroProcessor Engineering
\ 133 Hill Lane
\ Southampton SO15 5AF
\ England
\
\ tel: (+44) 2380 631441   (international)
\           02380 631441   (domestic)
\
\ email: mpe@mpeltd.demon.co.uk

\ System Configuration Registers (not offset from MBAR)
$0000F2 equ MBAR                \ Module Base Address Register
$0000F4 equ SCR                 \ System Control Register
$0000F4 equ SCRh                \ System Control Register (high)
$0000F6 equ SCRl                \ System Control Register (low)

\ All SIM module register groups below are specified as offsets
\ from the MBAR (Module Base Address register).

\ External Bus Interface Registers (offset from MBAR)
$000011 equ PACNT               \ Port A Control Register
$000013 equ PADDR               \ Port A Data Direction Register
$000015 equ PADAT               \ Port A Data Register
$000016 equ PBCNT               \ Port B Control Register
$000018 equ PBDDR               \ Port B Data Direction Register
$00001A equ PBDAT               \ Port B Data Register


\ Interrupt Controller Registers (offset from MBAR)
$000020 equ LICR1               \ Latched Interrupt Controller Register 1
$000022 equ LICR2               \ Latched Interrupt Controller Register 2
$000024 equ PICR                \ Peripheral Interrupt Control Register
$000027 equ PIVR                \ Programmable Interrupt Vector Register


\ Chip Select Registers (offset from MBAR)
$000040 equ BR0                 \ Base Register 0
$000042 equ OR0                 \ Option Register 0
$000044 equ BR1                 \ Base Register 1
$000046 equ OR1                 \ Option Register 1
$000048 equ BR2                 \ Base Register 2
$00004A equ OR2                 \ Option Register 2
$00004C equ BR3                 \ Base Register 3
$00004E equ OR3                 \ Option Register 3


\ UART Module Registers (offset from MBAR)
$000101 equ UMR1                \ UART Mode Register 1
$000101 equ UMR2                \ UART Mode Register 2
$000103 equ USR                 \ UART Status Register (read only)
$000103 equ UCSR                \ UART Clock Select Register (write only)
$000105 equ UCR                 \ UART Command Register
$000107 equ URB                 \ UART Receive Buffer (read only)
$000107 equ UTB                 \ UART Transmit Buffer (write only)
$000109 equ UIPCR               \ UART Input Port Change Register (read only)
$000109 equ UACR                \ UART Auxillary Control Register (write only)
$00010B equ UISR                \ UART Interrupt Status Register (read only)
$00010B equ UIMR                \ UART Interrupt Mask Register (write only)
$00010D equ UBG1                \ UART Baud Rate Generator prescaler (high)
$00010F equ UBG2                \ UART Baud Rate Generator prescaler (low)
$000119 equ UIVR                \ UART Interrupt Vector Register
$00011B equ UIP                 \ UART Input Port Register
$00011D equ UOP1                \ UART Output Port Data Register 1
$00011F equ UOP0                \ UART Output Port Data Register 0


\ Timer Module Register (offset from MBAR)
$000120 equ TMR1                \ Timer 1 Mode Register
$000122 equ TRR1                \ Timer 1 Reference Register
$000124 equ TCR1                \ Timer 1 Capture Register
$000126 equ TCN1                \ Timer 1 Counter
$000129 equ TER1                \ Timer 1 Event Register
$00012A equ WRR                 \ Watch dog Reference Register
$00012C equ WCR                 \ Watch dog Counter Register
$000130 equ TMR2                \ Timer 2 Mode Register
$000132 equ TRR2                \ Timer 2 Reference Register
$000134 equ TCR2                \ Timer 2 Capture Register
$000136 equ TCN2                \ Timer 2 Counter
$000139 equ TER2                \ Timer 2 Event Register


\ M-Bus Module Registers
$000141 equ MADR                \ M-Bus Address Register
$000143 equ MFDR                \ M-Bus Frequency Divider Register
$000145 equ MBCR                \ M-Bus Control Register
$000147 equ MBSR                \ M-Bus Status Register
$000149 equ MBDR                \ M-Bus Data I/O Register

