\ CW by Mark "Captain Chaos" Davis (G0KHB)

((
This program will display text in CW (Morse Code) upon either the system's
console or the system's LEDs.  You can either use the "low level" wordset,
CW-EMIT, CW-TYPE and CW-$ or choose to use them as you system wordset by
invoking CW-DRIVERS.  Before using these words, run either CW-SET-TEXT or
CW-SET-LEDS depending on whether you want the output to come out on the
system console or on the LEDs.
))

\ --------------------------------------------------------------------------

[undefined] CWDOTTIMEINMS [if] #100 constant CWDOTTIMEINMS [then]

variable cw-state

defer cw-on
defer cw-off
defer cw-wait

\ --------------------------------------------------------------------------

: cw-text-on  true  cw-state ! ;

: cw-text-off false cw-state ! ;

: cw-text-wait
  0 do
    cw-state @ if [char] - else [char] _ then emit
  loop
;

: cw-set-text
  false cw-state !
  assign cw-text-on   to-do cw-on
  assign cw-text-off  to-do cw-off
  assign cw-text-wait to-do cw-wait
;

\ --------------------------------------------------------------------------

: cw-leds-on
  cw-state @ if led-init false cw-state ! then
  led-on
;

: cw-leds-off
  cw-state @ if led-init false cw-state ! then
  led-off
;

: cw-leds-wait
  CWDOTTIMEINMS * ms
;

: cw-set-leds
  true cw-state !
  assign cw-leds-on   to-do cw-on
  assign cw-leds-off  to-do cw-off
  assign cw-leds-wait to-do cw-wait
;

\ --------------------------------------------------------------------------

create  cw-table

", X .-..-. "           \ This, the coding of '"', is patched up below.

", A .-    "    ", 0 ----- "    ", / -..-.  "
", B -...  "    ", 1 .---- "    ", + .-.-.  "
", C -.-.  "    ", 2 ..--- "    ", = -...-  "
", D -..   "    ", 3 ...-- "    ", . .-.-.- "
", E .     "    ", 4 ....- "    ", ! --..-- "
", F ..-.  "    ", 5 ..... "    ", , --..-- "
", G --.   "    ", 6 -.... "    ", ( -.--.- "
", H ....  "    ", 7 --... "    ", ) -.--.  "
", I ..    "    ", 8 ---.. "    ", ? ..--.. "
", J .---  "    ", 9 ----. "    ", - -....- "
", K -.-   "                    ", \ -..-.  "
", L .-..  "                    ", : ---... "
", M --    "                    ", ; -.-.-. "
", N -.    "
", O ---   "
", P .--.  "
", Q --.-  "
", R .-.   "
", S ...   "
", T -     "
", U ..-   "
", V ...-  "
", W .--   "
", X -..-  "
", Y -.--  "
", Z --..  "

",  ~"
", "

char " cw-table 1+ c!   \ Patch CW pattern for the double quote character.

\ --------------------------------------------------------------------------

: cw-lookup     \ char -- pointer | 0 ;
  cw-table >r
  begin
    r@ c@ 0=            \ End of pattern table?
    if                  \ Yes:
      drop              \   Discard CHAR.
      r> drop           \   Discard Table pointer.
      0 exit            \   Bail out.
    then
    r@ 1+ c@            \ Fetch this pattern "index" char.
    over <>             \ Is this the pattern we want?
  while
    r> dup c@ + 1+ >r   \ Step to next entry in table.
  repeat
  drop                  \ Discard required char.
  r>                    \ Point to first char of the pattern.
;

\ --------------------------------------------------------------------------

: cw-to-upper   \ char -- upperchar ;
  dup  [char] a >=
  over [char] z <= and
  if
    [char] a [char] A - -
  then
;

\ --------------------------------------------------------------------------

: cw-emit       \ char -- ;
  cw-to-upper cw-lookup
  ?dup if
    count bounds
    do
      i c@ [char] . = if cw-on 1 cw-wait cw-off 1 cw-wait then
      i c@ [char] - = if cw-on 3 cw-wait cw-off 1 cw-wait then
      i c@ [char] ~ = if cw-off 6 cw-wait then
    loop
    cw-off 3 cw-wait
  then
;

\ --------------------------------------------------------------------------

: cw-type       \ string$ -- ;
  bounds ?do i c@ cw-emit loop
;

\ --------------------------------------------------------------------------

: cw-$.         \ string$ -- ;
  count cw-type
;

\ --------------------------------------------------------------------------

: cw-drivers    \ -- ;
  assign cw-emit to-do emit
  assign cw-type to-do type
;

