\ 68000 goodies file
\ *****************************************************************
\
\	Hiden Analytical Limited, Quadrupole Mass Spectrometers
\   for vacuum, gas, surface and plasma analysis.
\
\ *****************************************************************
\ Author:
\	Steve Doughton 	   7th Sept 1993
\ Address:
\	Hiden Analytical Limited
\   231 Europa Boulevard
\	Gemini Business Park
\	Warrington
\	Cheshire
\   WA5 5TN
\	England
\
\ -- Semaphore structure                    S.B.D. -- 16/3/93 --  
\ see also SEMAPHORE in MULTI68K.FTH

\ This code replaces REQUEST & SIGNAL in MULTI68K because it allows a task to lock 
\ a semaphore multiple times

struct /semaphore
  int >lock_count
  int >owner
end-struct

interpreter
: semaphore
  /semaphore buffer:
;
target

: GET		\ semaphore -- ; wait until semaphore is available
	DUP >owner @ SELF = 			\ does SELF already own it?
	IF
		>lock_count INCR		\ increment counter
	ELSE
		DUP >lock_count 		\ add offset outside loop
		BEGIN
			SAVE-INT		\ disable intrupts in case counter 0
			OVER @			\ while counter is != 0
		WHILE
			RESTORE-INT
			PAUSE			\ let other tasks have a go
		REPEAT
		SWAP INCR			\ increment counter
		RESTORE-INT			\ safe as soon as lock count non-zero
		SELF SWAP >owner !		\ tag ownership field
	THEN
;

: CGET		\ semaphore -- t|f ; get semaphore if available
	DUP >owner @ SELF = 			\ does SELF already own it?
	IF
		>lock_count INCR		\ increment counter
	ELSE
		DUP >lock_count 		\ add offset outside loop
		SAVE-INT			\ disable intrupts in case counter 0
		OVER @			 	\ while counter is != 0
		IF
			RESTORE-INT
			2DROP FALSE EXIT
		THEN
		SWAP INCR			\ increment counter
		RESTORE-INT			\ safe as soon as lock count non-zero
		SELF SWAP >owner !		\ tag ownership field
	THEN
	TRUE
;


: RELEASE	\ semaphore -- ; decrement counter if not zero
	DUP >owner @ SELF = 
	IF
		>lock_count DUP @ 		\ As SELF owns this no one else can
		IF				\ change it so it can not change
			DUP DECR 		\ between @ and DECR.
		THEN
	THEN
	DROP
;

: UNLOCK	\ semaphore -- ; release totally 
	DUP >owner @ SELF = 			\ Ensure we own it - belt & braces this
	IF
		DUP >lock_count 0! 		\ release by setting lock count to 0
	THEN
	DROP
;

\	SM112 Steve Doughton 10th March 1997
\		Added ?OWN to check owner and lock count of semaphore.

: ?OWN		\ semaphore -- t|f ; SM112 check if we own semaphore
	DUP >owner @ SELF = 			\ Ensure we own it - 
	SWAP >lock_count @ 0<> 			\ Check lock count not 0
	AND
;


