\ MPE PowerForth/32 software floating point package
\ IEEE format conversion utilities [ap] 03/01/02
\ Convert from 32-bit exponent 32-bit mantisa to
\ IEEE single presition 32-bit float

\ Written and contributed by Alberto Pasquale
\ 20030605 SJD001 Optimised and corrected for 8 bit exponent

\ Tested on X68K v6.1

decimal

: FP>IEEE ( fp -- ieee32 )
  ?DUP IF				\ Don't convert 0
  126 + 23 LSHIFT			\ IEEE biased 127 FP has 1+
  OVER 0< IF $80000000 OR THEN SWAP ABS	\ FP signed mantis, set IEEE sign bit 
  $3FFFFFFF AND 7 RSHIFT OR THEN	\ clear msb IEEE hiden bit
;
 
: IEEE>FP ( ieee32 -- fp )
   DUP IF				\ Don't convert 0
     DUP				\ save a copy to get the sign
     8 LSHIFT 1 RSHIFT $40000000 OR 
     OVER ?NEGATE
     SWAP
     23 RSHIFT $FF AND 126 - 		\ shifted for FP exponent
   ELSE
     DUP				\ was already 0
   THEN 
;


