\ building defining words into the target

(( 
This first word is very simple and compiles and executes properly
both when cross compiling, and on the target. All defining words
must have a DOES> or ;CODE portion for correct cross compilation.
)))
: test1		\ n -- ; compiles 0..n-1
  create  0 do  i c,  loop  does>  ;

5 test1 jim
10 test1 bert

((
The cross compiler builds an analogue of the defining word
into the host. Words between CREATE and DOES> or CREATE and ;CODE
must exist either as special cases in the cross compiler, or in the
cross compiler's FORTH vocabulary, which is just the Forth system on
which the compiler is built.

If a word is needed between CREATE and DOES> or CREATE and ;CODE that
does not exist, it must be added to the host's Forth vocabulary. This
can be done using the HOST-COMPILATION and TARGET-COMPILATION directives.
))

decimal

host-compilation
only forth definitions

: functn	\ n -- n' ; this version is built into the host
  dup *  ;

target-compilation

: functn	\ n -- n' ; this version is built into the target
  dup *  ;

: table-builder	\ -- ; n -- f(n) ; builds a table
  create  16 0 do  i functn c,  loop
  does>  + c@  ;

table-builder simple-square


