\ ***************************************************************
\ Module:       hd-io2.fth
\               Contains intermediate file data IO functions
\ Author:       Jeremy Moller
\ Organisation: CEM Systems Ltd, Belfast
\ Copyright:    1999
\ ******************************************************************

: read-hd-block ( block buffer -- t/f )
    0 BLOCK_SIZE read-d-block ;

: write-hd-block ( block buffer -- t/f )
    write-f-blk ;

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

: read-d-block ( block buffer b-start size -- t/f )
\   cr ." Reading>" 2 pick .lword space 3 pick . over . dup .
    3 pick DISK_SIZE < if       	\ test block 
        2dup BLOCK_SIZE =       	\ To end
        swap 0= and if          	\ From start and
            2drop
            read-f-blk                  \ full, fast block read
        else
            read-p-blk                  \ partial block read
        endif
    else
        2drop 2drop             	\ outside file range
        false
    endif
 ;

: write-hd-block2 { l_block l_buffer l_b-start l_b-end -- t/f }
\   cr ." Writing>" 2dup .lword space .
    l_block DISK_SIZE < if
        l_b-end BLOCK_SIZE =        	\ To end
        l_b-start 0= and if         	\ From start and
            l_block l_buffer write-f-blk \ full block write
        else
            l_block l_buffer l_b-start l_b-end write-p-blk \ partial write to disk, via cache
        endif
    else
        false       			\ outside range
    endif
;

