\ ***************************************************************
\ Module:       structs.fth
\               Contains defintions of data structures used
\ Author:       Jeremy Moller
\ Organisation: CEM Systems Ltd, Belfast
\ Copyright:    1999
\ ******************************************************************

((
This module defines that data structures that are to be used for
the filesystem
))

#11 equ PATH-LENGTH
5   equ PATH-LIMIT
PATH-LIMIT PATH-LENGTH * PATH-LIMIT + equ PATH-STRING

PATH-LENGTH 1+ field-type lstring



struct dir-struct
    int      ->file-number      \ the FLD record number
    lstring  ->file-name
end-struct

struct file-extents
    int  ->extent-start     	\ location of data
    int  ->extent-size      	\ size of data
end-struct

#10 equ NO-OF-EXTENTS
NO-OF-EXTENTS file-extents *    equ EXTENT_LIST



\ FILE LIST DESCRIPTOR and FILE CONTROL BLOCK
struct FLD-rec
    int  ->next-fcb         	\ FCB, points to next FCB
    int  ->file-size            \ number of bytes used in file
    int  ->file-blocks      	\ number of block used by file
    short  ->prev-dir   
    short  ->file-type          \ data, directory or system
    int  ->file-last-mod        \ data last written
    int  ->file-expansion   	\ size of increase
    int  ->open-tables      	\ FCB, current number of open tables
    int  ->fld-no           	\ FCB, ptr to FLD
    int  ->extent-start-0   	\ location of data
    int  ->extent-size-0        \ size of data
    int  ->extent-start-1
    int  ->extent-size-1
    int  ->extent-start-2
    int  ->extent-size-2
    int  ->extent-start-3
    int  ->extent-size-3
    int  ->extent-start-4
    int  ->extent-size-4
    int  ->extent-start-5
    int  ->extent-size-5
    int  ->extent-start-6
    int  ->extent-size-6
    int  ->extent-start-7
    int  ->extent-size-7
    int  ->extent-start-8
    int  ->extent-size-8
    int  ->extent-start-9
    int  ->extent-size-9
    int  ->indirect-block
    int  ->indirect0
    int  ->index-indirect
    int  ->indirect1
end-struct

struct indir-extent
    int  ->ind-extent-start
    int  ->ind-logical-end
end-struct


$5a5affff   equ VALID_OTB

\ Defines details of files that a task has open
struct open-table-struct
    int  ->next-otb
    int  ->r/w-data-ptr
    int  ->valid-otb
    int  ->fcb-number
end-struct

$5a1234a5 equ CEM_FORMAT        \ a code to show it's DOS type

struct root-block
    int ->CEM_FORMAT
    int ->USAGE_BLOCK0
    int ->FLD0_BLOCK
    int ->DATA_BLOCK0
    int ->init-time
    lstring ->vol-name
    int ->vol-size  		\ max blocks
    int ->fd-size   		\ number of
end-struct

struct boot-block
    int ->primary-boot      	\ location of application
    int ->primary-size
    int ->backup-boot
    int ->backup-size
    int ->CEM_FORMAT-B
end-struct

struct block-alloc
    int ->last-amount
    int ->#blocks
    int ->start-block
    int ->start-address
    int ->first-amount
end-struct

struct file-extension
    int ->ext-fid
    int ->ext-size
    int ->ext-start
    int ->ext-no
end-struct


