\ ***************************************************************
\ Module:	definitions.fth
\		Contains filesystem definitions
\ Author:	Jeremy Moller
\ Organisation:	CEM Systems Ltd, Belfast
\ Copyright:	1999
\ ******************************************************************


\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

#512 constant MAX_FILES
#512 constant BLOCK_SIZE		\ block size on hard disk

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

BLOCK_SIZE FLD-REC /	equ FLD/BLOCK
BLOCK_SIZE DIR-STRUCT /	equ DIR/BLOCK

BLOCK_SIZE 8 * 		equ BLOCKS/BIT_TABLE

#16 equ MIN_EXP_SIZE
MIN_EXP_SIZE #1024 *	constant MIN_EXPANSION
0			constant NO_EXPANSION


0 value DISK_SIZE
0 value USAGE_TABLE_SIZE
0 value FLD-SIZE
0 value USAGE_BLOCK0
0 value FLD0_BLOCK
0 value DATA_BLOCK0

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ these are predefined
00 equ BOOT_BLOCK0
01 equ BOOT_BLOCK1
02 equ ROOT_BLOCK
03 equ ROOT_DIR_BLOCK
04 equ USAGE_BLOCK
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

BLOCK_SIZE buffer: bit_block_buffer

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

01 equ DIR_BLOCK_SIZE

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ flag in FLD to show file type

$5a01 equ FILE-FTYPE
$5a33 equ DIR-FTYPE
$5a58 equ SYS-FTYPE

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

char / equ DIR-DELIMIT
char . equ THIS-DIR

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


