

BLOCK_SIZE equ INDIR_SIZE
INDIR_SIZE INDIR-EXTENT / equ #INDIR-EXTENT
INDIR-EXTENT buffer: *ext-buff

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

\ this adds a new indirect extent to a file as required
: need-indirect-extent { l_*struct l_fid | l_*ind_block l_oc -- t/f }
  FALSE -> l_oc
  l_fid fcb-addr ->indirect-block -> l_*ind_block

  l_*ind_block @ 0= if	\ need first indirect block ?
    #1 need-blocks l_*ind_block !	\ allocate new indirect extent block
    l_*ind_block @ erase-block drop
    l_fid fcb-addr update-fcb drop
  endif

  INDIR_SIZE 0 do			\ find empty indirect block
    l_*ind_block @			\ block
    *ext-buff				\ buffer
    i 					\ start
    INDIR-EXTENT			\ sixe
    read-p-blk if
      *ext-buff ->ind-extent-start @ 0= if	\ new block

        l_*struct ->ext-start @		\ get selected block start
\       ." Starting @" dup .decimal space l_*struct ->ext-size @ .decimal ." blocks "
	*ext-buff ->ind-extent-start !	\ save physical start
	l_fid fcb-addr ->file-blocks @	\ current size
	l_*struct ->ext-size @ + dup	\ plus extension
	l_fid fcb-addr ->file-blocks !	\ save new file blocks
	*ext-buff ->ind-logical-end !	\ save new logical end

	l_*ind_block @			\ block
	*ext-buff			\ buffer
	i 				\ start
	i INDIR-EXTENT +		\ end
	write-p-blk drop
	l_fid fcb-addr update-fcb -> l_oc
	leave
				
      endif
    else
      leave
    endif
  INDIR-EXTENT +loop
  l_oc ;

\ -----------------------------------------------------------------

\ "l_remaining" is number of ( blocks remaining - 1 )
\ this gets the physical address of the logical block via indirection
: get-indirect-extent { l_fid l_remaining | l_indi l_req l_hd_block -- phys  }
  -1 -> l_hd_block
  l_fid fcb-addr ->indirect-block @ -> l_indi
  l_fid get-r/w-b-ptr -> l_req
\ cr ." Seeking " l_req .decimal ." remaining " l_remaining .decimal 
  INDIR_SIZE 0 do	
    l_indi				\ block
    *ext-buff				\ buffer
    i 					\ start
    INDIR-EXTENT			\ size
    read-p-blk if
      *ext-buff ->ind-extent-start @ 0<> if	\ indirect extent defined
        l_req *ext-buff ->ind-logical-end @ - dup 0< if		\ get selected block start
          drop
	  *ext-buff ->ind-extent-start @ l_remaining + -> l_hd_block
\         cr ." Indir block @" l_hd_block .decimal l_remaining .decimal
	  leave
        else
	  -> l_remaining
        endif
      else
        leave				\ non defined
      endif
    else
      leave				\ block read error
    endif
  INDIR-EXTENT +loop
  l_hd_block ;

\ -----------------------------------------------------------------

\ this deletes all associated indirect blocks 
: delete-indir-extent { l_indirect_blk l_start | -- }
  INDIR_SIZE 0 do			\ find used indirect blocks
    l_indirect_blk			\ block
    *ext-buff				\ buffer
    i  					\ start
    INDIR-EXTENT			\ sixe
    read-p-blk if
      *ext-buff ->ind-extent-start @ 0<> if	\ indirect extent defined
        *ext-buff ->ind-extent-start @		\ get physical start
\       cr ." Releasing from " dup .decimal
        *ext-buff ->ind-logical-end @ l_start -	\ get length
\       dup .decimal ." blocks " 
        free-blocks
        *ext-buff ->ind-logical-end @ -> l_start 
      else
        leave				\ not defined
      endif
    else
      leave				\ block read error
    endif
  INDIR-EXTENT +loop
  l_indirect_blk #1 free-blocks		\ release indirect list block
;
	
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ a clatter of test words for file extensions

variable jerry1
variable jerry2

: ccreate ( -- )
	s" fred" 100 100 create-file .
	s" billy" 100 100 create-file .
	s" fred" open-file jerry1 !
	s" billy" open-file jerry2 ! ;

: cdelete ( -- )
	s" fred" delete-file .
	s" billy" delete-file . ;

: ll { | l_*buff -- }
	$100 allocate if
		drop exit
	endif
	-> l_*buff
	00
	l_*buff $fe bounds ?do
		dup i c!
		1+
	loop
	drop
	l_*buff $fe jerry1 @ write_f .
	l_*buff free drop ;

$2fe equ TEST_REC_SIZE

: kk { | l_*buff -- }
	TEST_REC_SIZE allocate if
		drop exit
	endif
	-> l_*buff
	00
	l_*buff TEST_REC_SIZE bounds ?do
		dup i c!
		1+
	loop
	drop
	l_*buff TEST_REC_SIZE jerry2 @ write_f .
	l_*buff free drop ;

: jj
	#15 0 do
		." ll>" ll
		." kk>" kk cr
	loop ;


