\  This file is always required as it defines the base protocol
((
Copyright (c) 1999

MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)2380 631441
fax: +44 (0)2380 339691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk
))


\ This protocol is designed for point to point, for multiple slaves additional ss lines
\ will need to be provided 


\ ---------------------------------------------------------------------------
\ read a byte, clock is idle when low
\ ----------------------------------------------------------------------------

: read_byte_spi		\ -- byte
  0	        			\ -- 0 		; put blank byte on the stack - will be used to hold the data byte		
  8 0 do				\ -- 0 		; loop for 8 times to read in each bit of byte
    sck_high 	 		        \ -- 0		; set clock HIGH      
    1 lshift miso@ OR			\ -- in_bits	; shift stack left 1, miso
    sck_low 				\	        ; set clock LOW     
  loop					\        	; end the loop 
;

\ ---------------------------------------------------------------------------
\ write a byte, clock is idle when low
\ ----------------------------------------------------------------------------

: write_byte_spi	\ byte --   
  8 0 do			\ -- byte		; loop for 8 times     		         
    dup $080 AND 		\ -- byte mask		; mask msb bit of byte
    if				\ -- byte		; test mask, if high
      mosi_high			\ -- byte		; set miso high		
    else    			\ -- byte		; if mask is high
      mosi_low        		\ -- byte		; set mosi low
    endif			
    1 lshift			\ -- byte		; left shift byte by 1    
    sck_high			\ -- byte		; set clock high
    sck_low			\ -- byte		; set clock low
  loop				\ -- byte 		; end loop 
  drop				\ 		        ; drop the byte from stack 
;
\ ----------------------------------------------------------------------------

