\ DLE-STX state machine example
\ Copyright Synics AG

decimal

: crc8		\ crc n -- crc ; CRC-8 algorithm
		\ see DALLAS app note 27 and DS1990 chip
  8 0 do
    2dup xor 1 and if
      swap $18 xor 2/ $80 or swap
    else
      swap 2/ swap
    then
    2/
  loop
  drop
;


\ variables

variable p_frame_in
variable crc_out
variable crc_in

$200 constant COMM_BUF_IN_SIZE
COMM_BUF_IN_SIZE buffer: comm_buf_in

\ actions

: init_frame \ c --
  drop
  0 p_frame_in !
  0 crc_in !
;

: accept_binary \ c --
  crc_in c@ over crc8 crc_in c!
  p_frame_in @ comm_buf_in + c!
  p_frame_in @ 1+ COMM_BUF_IN_SIZE min p_frame_in !  \ limit
;

defer handle_frame

: (handle_frame) \ --
  base @ >r  hex
  comm_buf_in p_frame_in @ bounds
  do  i c@ 0 3 d.r  loop
  r> base !  cr
;

: show_frame \ --
  assign (handle_frame) to-do handle_frame ;

\ show_frame

: close_frame \ c --
  crc_in c@ = if
    handle_frame
  then
;


\ ***************************************
\ state machine for the protocol handling
\
\ typical usage:   key get_frame cycle
\ ***************************************

ctrl P constant DLE
ctrl B constant STX
ctrl C constant ETX

\ state names
0
  1+ dup constant idle_state
  1+ dup constant start_state
  1+ dup constant datain_state
  1+ dup constant dle_state
  1+ dup constant crcin_state
FSM: get_frame	\ n --

idle_state   state:
   DLE start_state  action:  drop
       idle_state   default: drop

start_state  state:
   STX datain_state action:  init_frame
       idle_state   default: drop

datain_state state:
   DLE dle_state    action:  drop
       datain_state deafult: accept_binary

dle_state    state:
   DLE datain_state action:  accept_binary
   STX datain_state action:  init_frame
   ETX crcin_state  action:  drop
\  ctrl [ dle_state  action:  abort
       idle_state   default: drop

crcin_state  state:
       idle_state   default: close_frame

