\ Miscellaneous math functions

((
Copyright (c) 2001
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
))

: lg2		\ n -- lg2(n) ; integer base 2 logarithm
  0 swap 2/
  begin  dup while  2/  swap 1+ swap  repeat
  drop
;

: ^^		\ n m -- n^m ; integer raise n to the power m
  dup 0=
  if  2drop 1  exit  then
  abs swap >r  1
  begin
    over 1 and
    if  r@ *  then
    r> dup * >r
    swap 2/ tuck
  0= until
  nip  r> drop
;


((
Taken from comp.lang.forth. A 32 bit system is assumed.

Parity can be generated by XORing the upper and lower 16 bits,
then the upper and lower 8 bits of the resulting 16 bits
  "   "    "    "    "   4  "    "  "      "      8 bits
  "   "    "    "    "   2  "    "  "      "      4 bits
  "   "    "    "    "   1  "    "  "      "      2 bits
))

: P2		\ 32b -- Flag 32b
  DUP >R
  DUP 16 rshift XOR
  DUP  8 rshift XOR
  DUP  4 rshift XOR
  DUP  2 rshift XOR
  DUP  1 rshift XOR
  1 AND
  R>
;


: sqrt		\ n1 -- n2
\ *G return the square root of a single number.
  0 TUCK
  ?DO  1+  DUP 2* 1+  +LOOP
;

: dsqrt		\ d -- n
\ *G Square root of a double number. This code assumes a
\ ** 32 bit Forth. Taken from comp.lang.forth and we apologise
\ ** for losing the attribution to the original author.
  { | a p -- }
  0 to a  0 to p
  #32 0 do
    a 2* over 0< if 1+ then to a	\ shift MSB into a
    2dup d+				\ shift x
    a 2* over 0< if 1+ then to a	\ shift MSB into a
    2dup d+				\ shift x
    p 2* to p				\ shift p one place
    a p 2* > if
      a p 2* 1+ - to a
      p 1+ to p
    then
  loop
  2drop  p
;

: magnitude	\ x y -- sqrt(x^2+y^2)
\ *G Calculate sqrt(x^2+y^2) to produce the vector magnitude.
  dup * swap dup * + sqrt
;


