\ DEVTOOLS.FTH - Tools for development use

((
Copyright (c) 2002, 2003, 2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691


To do
=====

Change history
==============
20040107 SFP003 Added option of .WORD and friends without division.
20030320 SFP002 Added FlushKeys where appropriate
20020915 SFP001 Removed INTERNAL/EXTERNAL.
		Made DUMP safe for len=0.
		Added DOCGEN comments
))

decimal

\ ===========
\ *! devtools
\ *T Development tools
\ ===========
\ *P The file COMMON\DEVTOOLS.FTH supplies words that are most used
\ ** during development and debugging.

\ SFP003...
1 equ simple?	\ -- n
\ *G Set this flag non-zero to generate .xWORD to avoid divisions.
\ ** On some CPUs, a division operation is slow.

simple? [if]

internal
: .nibble	\ n --
\ *G Convert a nibble to a hex ASCII digit and display it.
  $0F and  dup 9 >
  if  7 +  then
  $30 + emit
;
external

: .BYTE		\ b -- 
  dup #4 rshift .nibble .nibble
;

: .WORD		\ w --
  dup #12 rshift .nibble
  dup 8 rshift .nibble
  dup 4 rshift .nibble
  .nibble
;

32bit? [if]

internal
: .topnib	\ x -- x<<4
  dup #28 rshift .nibble  4 lshift
;
external

: .LWORD	\ x --
  .topnib .topnib .topnib .topnib
  ." :"
  .topnib .topnib .topnib .topnib
  drop
;
  
: .DWORD	\ x --
  .lword
;
[then]

[else]

: .BYTE		\ b -- 
\ *G Display b as two hex digits.
  base @ hex  swap
  0 <# # # #> type
  base !
;

: .WORD		\ w --
\ *G Display w as four hex digits.
  base @ hex  swap
  0 <# # # # # #> type
  base !
;

32bit? [if]
: .LWORD	\ x --
\ *G Display x as eight hex digits.
\ ** The separator ":" makes the output easier to read.
\ ** Future releases of MPE Forths will treat the ":"
\ ** character as having no effect on number input parsing.
\ ** This character is chosen because it does not conflict
\ ** with the current use of the "." and "," characters
\ ** for numbers.
\ ** This word is only compiled for 32 bit targets.
  base @ hex  swap
  0 <# # # # # ascii : hold # # # # #> type
  base !
;

: .DWORD	\ x --
\ *G A synonym for .LWORD.
  .lword
;
[then]

[then]
\ ...SFP003

: .ASCII	\ char --
\ *G The top bit of char is zeroed. If char is in the range
\ ** 32..126 it is displayed, otherwise a "." is displayed.
  $7F and  dup $20 $7E within? 0=
  if  drop $2E  then
  emit
;

: DUMP		\ addr len --
\ *G Display (dump) len bytes of memory starting at addr.
[defined] FlushKeys [if] FlushKeys [then]	\ SFP002
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i c@ .byte  loop          \ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i c@ .byte  loop          \ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr
;

32bit? [if]
: LDUMP		\ addr len -- ; dump 32 bit long words
\ *G Display (dump) len bytes of memory starting at addr
\ ** as 32 bit words.
[defined] FlushKeys [if] FlushKeys [then]	\ SFP002
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i @ .lword  4 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i @ .lword  4 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;

: WDUMP		\ addr len -- ; dump 16 bit half words
\ *G Display (dump) len bytes of memory starting at addr
\ ** as 16 bit half-words.
[defined] FlushKeys [if] FlushKeys [then]	\ SFP002
  bounds ?do				\ get limits
    cr  i .lword  space   i 8 + i       \ print address
    do  space i w@ .word  2 +loop	\ first eight bytes
    space  i $010 + i 8 +               \ gap
    do  space i w@ .word  2 +loop	\ second eight bytes
    2 spaces  i $010 + i                \ gap
    do  i c@ .ascii  loop               \ ascii o/p
    halt? ?leave			\ quit or halt
  $010 +loop                            \ until done
  cr  					\ restore base
;
[then]

: .S		\ --
\ *G Display the contents of the data stack without affecting it.
  cr  depth ?dup 0= if
    ." empty stack"  cr  exit
  endif
  ."      top"
  dup 0< #-4 ?throw  0 do
    i pick
    cr  dup s>d #15 d.r space	        \ show word in current base
    base @ #16 <>			\ if base is not HEX
    if  .lword  else  drop  then	\ also show it in HEX
    key? ?leave
  loop
  cr
;

: ?		\ a-addr --
\ *G Display contents of a memory location as a cell.
  @ .
;

decimal


\ ======
\ *> ###
\ ======

