\ Umbilical Forth messages file

((
Copyright (c) 1988-1998
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 1703 631441
fax: +44 1703 339691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk


Messages from host to target            001..07F
Messages from target to host            081..0BF
Status codes from host to target        0C1..0DF
Status codes from target to host        0E1..0FF

20000424 SFP003 Updated for systems with separate code space read/write
19980221 SFP002 Changed PUSH-CMND>H to TYPE-CMND>H and implemented
                string type command
19980216 MSD001 Changed message 0x0C from SLEEP-CMND>T to COPY-CMND>T
         MSD001 following implementation of the "send data buffer" command.
))


\ ****************************
\ messages from host to target
\ ****************************

hex

001 Equ execute-cmnd>t          \ primitive mess
002 Equ push-cmnd>t             \
003 Equ pop-cmnd>t              \
004 Equ s>t-cmnd>t              \ stack to target
005 Equ s>h-cmnd>t              \ stack to host
006 equ W@-cmnd>t               \ word fetch from target
007 equ W!-cmnd>t               \ word store to target
008 equ C@-cmnd>t               \ byte fetch from target
009 equ C!-cmnd>t               \ byte store to target
00A equ L@-cmnd>t               \ long word fetch from target
00B equ L!-cmnd>t               \ long word store to target
00C equ copy-cmnd>t             \ send data buffer from host to target          \ MSD001

harvard? [if]
00D equ W@C-cmnd>t		\ code word fetch from target
00E equ W!C-cmnd>t		\ code word store to target
00F equ C@C-cmnd>t		\ code byte fetch from target
010 equ C!C-cmnd>t		\ code byte store to target
011 equ L@C-cmnd>t		\ code long word fetch from target
012 equ L!C-cmnd>t		\ code long word store to target

012 equ max-cmnd>t              \ maximum command value
011 equ #host-messages
[else]
00C equ max-cmnd>t              \ maximum command value
00B equ #host-messages
[then]


\ ****************************
\ messages from target to host
\ ****************************

081 Equ key-cmnd>h               \ key command
082 Equ emit-cmnd>h              \ emit command
083 Equ type-cmnd>h              \ type command
084 Equ key?-cmnd>h              \ key? command
085 Equ .-cmnd>h                 \ . command


\ ********************************
\ status codes from host to target
\ ********************************
\ none!

0C0 Equ status>t-start
0DF Equ status>t-end


\ ********************************
\ status codes from target to host
\ ********************************
hex

0FF Equ OK!                     \ Successful
0FE Equ ACK!                    \ Acknowledge
0FD Equ ERROR!                  \ Bad command
0FC Equ SUFL!                   \ Data stack underflow
0FB Equ THROW!                  \ Throw occurred

0E0 Equ status>h-start          \ start of staus codes to host
0FF Equ status>h-end            \ end of staus codes to host

decimal

