\ ===========
\ *> romforth
\ *S Target BUFFER: and VARIABLE
\ ===========
\ *P The definitions below reorganise the use of RAM for ROM
\ ** PowerForth applications which are themselves to be put
\ ** in Flash or EPROM.

\ *P The variable RP points to the top of available RAM, and is decremented
\ ** by the amount of RAM required. The word BUFFER: allocates memory from
\ ** this space, returning its base (low) address. Words such as VARIABLE
\ ** can then be defined in terms of BUFFER.


: Buffer:	\ n -- ; -- addr
\ *G Return the address of an n byte buffer. Use in the form:
\ *C   <size> BUFFER: <name>
  abs negate rp +!			\ reduce buffer space
  rp @ constant				\ make constant of base address
;

: variable      \ -- ; -- addr ; replacement
\ *G Create a new variable. Use in the form:
\ *C   VARIABLE <name>
  cell buffer:
;

\ End-Up-Load

\ ======
\ *> ###
\ ======

