\ ROM Forth Intel Hex file upload tool      

((
Copyright (c) 1991..2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

20000530 SFP001 Converted for v6.1 targets

Changes:	See RELEASE.TXT for full details
))

\ ===========
\ *> romforth
\ *S Intel Hex transfers
\ ===========
\ *P The code in COMMON\ROMFORTH\INTELHEX.FTH provides a simple
\ ** way to transfer binary images from ROM PowerForth to a host.
\ ** The Intel Hex format is printable and can be captured (logged) by
\ ** most terminal emulators including AIDE.


internal

HEX
$10  constant line-length

variable CHECKSUM
variable RECORD
variable LENGTH
variable MEM-ADDRESS


: CHAR-TARGET   \ char --
  ser-key?
  IF  ser-key XOFF =
      IF  BEGIN  ser-key XON =  UNTIL  ENDIF
  ENDIF
  ser-emit  ;

: REM-CR        \ -- ; crlf to remote
  $0D CHAR-TARGET  $0A CHAR-TARGET  ;

: BIN-ASCII     \ n -- ascii
  0F AND  DUP 9 > IF  $037  ELSE  $030  ENDIF  +  ;

: byte-ascii    \ byte -- l-char h-char
  DUP BIN-ASCII  SWAP $010 /  BIN-ASCII  ;

: BYTE-TARGET	\ byte -- ; send byte to target
  $0FF AND  DUP checksum +!
  BYTE-ASCII CHAR-TARGET CHAR-TARGET  ;

: hex-HEADER	\ -- ; initialise record
  $03A CHAR-TARGET  CHECKSUM off  ;

: RECORD-LENGTH	\ -- ; send record length
  LENGTH @ BYTE-TARGET  ;

: START-ADDRESS	\ -- ; send start address
  MEM-ADDRESS @ 0 $0100 um/mod
  BYTE-TARGET  BYTE-TARGET  ;

: TYPE-OF-RECORD	\ -- ; send record type
  RECORD @ BYTE-TARGET  ;

: DATA		\ -- ; send data block
  Mem-Address @  LENGTH @  bounds
  ?DO  I c@ BYTE-TARGET  LOOP  ;

: SEND-CHECK	\ -- ; send checksum
  CHECKSUM @ negate BYTE-TARGET
  CHECKSUM off  ;

: SEND-RECORD	\ -- ; send one complete record
  hex-HEADER RECORD-LENGTH START-ADDRESS
  TYPE-OF-RECORD DATA SEND-CHECK REM-CR  ;

: SEND-LAST-RECORD	\ -- ; send last record
  LENGTH off
  1 RECORD !  SEND-RECORD  0 RECORD !  ;

decimal

: ?User-Start	\ --
  cr ." Start ASCII receiver - [PgDn],7 with ProComm"
  cr ." then press SPACE-BAR" cr
  BEGIN key BL = UNTIL
;

: ?User-Finish	\ --
  BEGIN key #13 = UNTIL
  cr ." File Transfer Successful" cr 
;

External

: HEX-DOWN	\ addr #bytes --
\ *G Send #bytes at addr from ROM PowerForth to the host in Intel
\ ** Hex format.
  ?User-Start                           \ Down-Load started ?
  swap MEM-ADDRESS !                    \ Upload from addr.
  line-length LENGTH !
  0 
  ?DO  SEND-RECORD
       length @ dup                     \ line length in CELLS
       MEM-ADDRESS +!                   \ update address and cou
  +LOOP                                 \
  send-last-record                      \
  ?User-Finish  ;                       \ Down-Load finished ?


\ ======
\ *> ###
\ ======

decimal

