\ Target text file words for use with the AIDE file server.

((
Copyright (c) 1991..2004
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

To do
=====
Permit file nesting.

Change history
==============
20040505 MPE005 Modified for AIDE 2.500 onwards.
20021004 SFP004 Refactored to use CATCH/THROW
20020917 SFP003 Refactored to reduce size
20000530 SFP002 Converted to v6.1 targets
19990509 SFP001 Rewritten for AIDE/PowerTerm.
                Removed support for USE
First Release: 29/04/91

Changes:        See RELEASE.TXT for full details
))

\ ===========
\ *> romforth
\ *S INCLUDE source code from AIDE
\ ===========
\ *P The file COMMON\ROMFORTH\TEXTFILE.FTH provides support for
\ ** compiling a source file from the AIDE server. The code has
\ ** been updated for AIDE version 2.500 onwards.


decimal

: end-load      \ -- ; switch back to keyboard input
\ *G This word is automatically performed at the end of a download
\ ** to tidy up the comms.
  xon/xoff off                  	\ turn off handshaking
  echoing on                    	\ turn echoing back on
;

internal

: file-error    \ n --
\ *G Handle an error when a file is being INCLUDEd.
  ^e ser-emit                           \ trigger host error
  CR ." Error # " .  SPACE here $. CR   \ show error
  end-load                              \ clean up
;

: $include	\ $addr -- ; compile host file, counted string
\ *G Given a counted string representing a file name, compile
\ ** the file from AIDE.
  ^f send$                      	\ send file name
  -1 send-block#                   	\ send last-p# - legacy
  1 send-block#                   	\ send first-p# - legacy
  synch-to-host                 	\ synchronise
  echoing off                   	\ not echoing
  xon/xoff on                   	\ initiate handshaking
[ blocks? ] [if]
  blk off
[then]
  0 to source-id  [compile] [		\ set up
  begin
    query				\   get user input
    ['] interpret catch ?dup if		\   interpret line
      file-error			\    display error
      s0 @ sp!				\    display error, clean data stack
    then
    echoing @
  until                                 \   do next line
;

external

: include       \ "<filename>" -- ; load file from host
\ *G Compile a file across the serial line from the AIDE file server.
\ ** Use in the form:
\ *C   include <filename>
\ *P The filename extension must be supplied.
  bl word                               \ get file name
  dup count upper                       \ convert to upper case
  $include				\ compile from file
;


\ ======
\ *> ###
\ ======

decimal

