\ ROM tools

((
Released for use with the MPE Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: +44 (0)1703 631441
tel: +44 (0)1703 339691
))

\ *************
\ Name handling - it is unlikely that these words will be needed
\ *************

((
: >LINK         
  >name n>link  
;

: LINK>         
  cell+ name>  
;
))


\ ***************
\ Debugging tools
\ ***************

HEX

: .BYTE         \ n --
  0 <# # # #> TYPE  
;

: .WORD         \ n -- 
  0 <# # # # # #> TYPE  
;

32bit? [if]
: .DWORD        \ n -- 
  0 <# # # # # [char] . hold # # # # #> TYPE  
;
[then]

: .ASCII        \ b --
  07F AND  DUP 020 07E WITHIN? 0=
  IF  DROP 02E  ENDIF  EMIT  
;

16bit? [if]
: dump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .WORD  i 010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@ .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

harvard? [if]
: Cdump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .WORD  i 010 bounds		\ print address
    do  space  i c@c .BYTE  loop	\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@c .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;
[then]
[then]
32bit? [if]
: dump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .DWORD  i 010 bounds		\ print address
    do  space  i c@ .BYTE  loop		\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@ .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;

harvard? [if]
: Cdump		\ addr len --
  BASE @ -rot  HEX  bounds		\ get limits
  ?DO
    CR  i .DWORD  i 010 bounds		\ print address
    do  space  i c@c .BYTE  loop	\ print byte
    2 SPACES  I 010 bounds		\ gap
    DO  I c@c .ASCII  LOOP		\ ascii o/p
    key? ?LEAVE				\ quit or halt
  010 +LOOP				\ until done
  BASE !  CR				\ restore base
;
[then]
[then]

: .S
  CR
  DEPTH ?DUP IF
    ."  top"  0
    DO  I PICK CR 8 U.R  LOOP
  ELSE
    ." Empty stack"
  ENDIF
  CR  
;

: ?
  @ .  
;


\ ******************
\ FORGET and friends
\ ******************

decimal

internal

: Trim		\ nfa-to-forget wid --
  dup >threads swap >#threads @ cells
  bounds do				\ for each thread
    ORIGIN- i @				\ fetch top link
    begin	\ -- nfa-t-f nfa2
      2dup origin- u> 0=		\ while nfa <= link
     while
       n>link @c			\  try next one
    repeat
    i !  ORIGIN+			\ update thread entry
  cell +Loop				\ step to next thread
  drop					\ release nfa
;

: (forget)      \ nfa -- ; forgets back to given nfa
  >r
  r@ ORIGIN-  FENCE @ ORIGIN-  U<  -121 ?throw
  VOC-LINK @
  BEGIN
    ORIGIN- R@ ORIGIN- OVER U<
   WHILE
    ORIGIN+ >voc-link @
    only forth definitions
  REPEAT
  ORIGIN+ dup voc-link !		\ voc-link -- ; pointer to top voc
  BEGIN
    r@ over				\ -- v-l nfa v-l
    trim				\ -- v-l ; cut links
    >voc-link @ ?dup 0=			\ check end of chain
  UNTIL
  r> n>link dp !			\ reset DP
;

external

: $FORGET       \ $addr -- ; forgets word name in given string
  count  current @ search-wordlist ?undef
  >name (forget)  
;

: FORGET	\ -- ; name to forget follows in input stream
  bl word  dup count upper  $forget  
;


\ **********
\ vocs order
\ **********

also root definitions               
: Vocs          \ --
  Voc-Link @
  Begin
    ?dup
   While               		\ wid --
    dup >vocname @ .name
    >voc-link @
  Repeat
;

: .Voc		\ context-array --
  @ ?dup If
    >vocname @ .name
  Endif
;

: Order
  cr ." Context: "  Context Vsize bounds
  Do  i .voc  cell +Loop
  cr ." Current: " Current .voc cr
;

previous definitions


((
\ **********
\ .hex 2.hex
\ **********
\ only necessary if the target is in a very bad way indeed
\ and even . will not work!!!


hex  

: .hex          \ n -- ; print n in hex
  4 0
  do  dup 0C 0 do 2/ loop               \ top 4 bits to bottom
      0F and  dup 9 >                   \ mask, check 0..9,A..F
      if  7 +  endif                    \  was A..F
      030 + (emit)                      \ convert to ASCII
      2* 2* 2* 2*                       \ get next 4 bits
  loop                                  \
  drop                                  \ drop n
;

: 2.hex
  cr 2dup  .hex space .hex  
;
))


