
\       Sieve of Eratosthenes

only forth definitions
decimal

: Eratos  ( -- ; stub to forget )
;

compiler
: []  ( index array -- addr ; return addr of array[index] )
  1- +
;
target

1024 constant #numbers          \ number of numbers to test against
#numbers buffer: table          \ array containing primes/not primes
                                \ 0 = Prime, 1 = Not Prime

: Eliminate  ( n -- ; eliminate all numbers of which 'n' is a factor )
  dup                           \ step, index
  Begin                         \
    over +                      \ step, index+step
    dup #numbers <=             \ while some more numbers
  While                         \
    1 over table [] c!          \ this number isn't a prime
  Repeat                        \
  2drop                         \ discard step, index
;

: Primes  ( -- ; find all primes )
  #numbers 1+  2                \ don't include self in numbers to discard
  Do                            \
    i eliminate                 \ discard all nos. of which I is a factor
  Loop                          \
;

: Fill-Table  ( b -- ; fill table with 'b's )
  #numbers 1+  1                \ for all numbers
  Do                            \
    dup i table [] c!           \ assume prime number
  Loop                          \
  drop                          \
;

: Sieve  ( -- )
  0 fill-table                  \ assume all prime numbers
  primes                        \ find all true prime numbers
;

: Test  ( n -- ; perform sieve 'n' times )
  0
  ?Do
    sieve
  Loop
;

: .Primes  ( -- ; display all prime numbers )
  cr
  #numbers 1+  1
  Do
    i table [] c@ 0=
    If
      i 10 .r
    Then
  Loop
  cr
;

: Run   \ -- ;
  .Primes
;

