\ MPE PowerForth/32 common software floating point package

((
Copyright (c) 2000
MicroProcessor Engineering
133 Hill Lane
Southampton SO15 5AF
England

tel: +44 (0)23 8063 1441
fax: +44 (0)23 8033 9691
net: mpe@mpeltd.demon.co.uk
     tech-support@mpeltd.demon.co.uk
web: www.mpeltd.demon.co.uk

From North America, our telephone and fax numbers are:
  011 44 23 8063 1441
  011 44 23 8033 9691

PLEASE NOTE OUR PHONE NUMBER CHANGE


19981029 MSD002 Corrected the code in S-> that accepted and returned a carry
         MSD002 flag of $00000000 or $FFFFFFFF; I had interpreted the word
         MSD002 "flag" in the comments in the 68K version in the Forth sense.
         MSD002 In the event, it appears that this flag *must* be 0 or 1...
19981029 MSD001 Delete all of the *common* FP stuff as it is now in the
         MSD001 common sub-directory.  (Not flagged.)


32-bit mantissa and 32-bit exponent
))


only forth definitions
decimal


\ =========
\ *> softfp
\ =========
\ *S High Level primitives
\ *P The software floating point pack requires several support primitives.
\ ** High level versions are provided in SFP16HI.FTH and SFP32HI.FTH for 16
\ ** and 32 bit targets. Some targets have coded versions in the CPU directory
\ ** and these will provide much better performance. The support file should
\ ** be compiled before the common file.


\ ------------------------------------------------------------------------------
\ shift routines
\ ------------------------------------------------------------------------------

compiler
: <<1		\ n -- n<<1
\ *G A compiler synonym for 2* or "1 LSHIFT".
  2*
;

: >>1           \ n -- n>>1
\ *G A compiler synonym for 2/ or "1 RSHIFT".
  u2/
;
target

: S->           \ n1 carry-in-flag --- n2 carry-out-flag
\ *G Perform a right shift, applying the carry in to the m.s. bit and
\ ** returning the carry out as 1 or 0.
  over >>1 swap                 \ Save original N1 and shift it right one bit.
  1 and                         \ Only use bottom bit of carry flag.            \ MSD002
  if                            \ Should MSB (carry-in bit) be zero or one?
    $80000000 or                \ MSB must be a one.
  else
    $7FFFFFFF and               \ MSB must be a zero.
  endif
  swap $00000001 and            \ Retrieve old N1 and create carry-out flag.    \ MSD002
;

: <-S		\ n1 carry-in-flag --- n2 carry-out-flag
\ *G Perform a left shift, applying the carry in to the l.s. bit and
\ ** returning the carry out as 1 or 0.
  over <<1 swap                 \ Save original N1 and shift it left one bit.
  if                            \ Should LSB (carry-in bit) be zero or one?
    $00000001 or                \ LSB must be a one.
  else
    $FFFFFFFE and               \ LSB must be a zero.
  endif
  swap $80000000 and 0<>        \ Retrieve old N1 and create carry-out flag.
;

: d<<1		\ xd -- xd<<1
\ *G One bit double left shift.
  swap 0 <-s            	\ lsc msc -- msc lsc<<1 carry ;
  rot swap <-s          	\ -- lsc<<1 msc<<1 carry ;
  drop                  	\ -- lsc<<1 msc<<1 ;
;

: d>>1		\ xd -- xd>>1
\ *G One bit double right shift.
  0 s->                 	\ lsc msc -- lsc msc>>1 carry ;
  rot swap s->          	\ -- msc>>1 lsc>>1 carry ;
  drop swap             	\ -- lsc>>1 msc>>1 ;
;

: D>>N		\ d m -- d>>m
\ *G M bit double right shift.
  dup 0> if
    0 do d>>1 loop
  else
    drop
  endif
;


\ ======
\ *> ###
\ ======

