\ TSEPOS 781 9 25 \

\ OPTIMISE:     Yank all the window properties into global space on entry to
\               wndproc.
\
\ Make KEY show and hide the caret (if active application window) to remove
\ all the judders
\
\ Add history buffers to accept
\
\ Add "scroll back" into device ala Linux TTY0

\ =======================================================================
( *> GENIO                                                              )
( **                                                                    )
( *N Text Console Device                                                )
( **                                                                    )
( *P This Generic IO Device provides a simple terminal type console     )
( ** window.                                                            )
( **                                                                    )
( *P In order to create a device use the GCONSOLE: definition given     )
( ** later.                                                             )
( **                                                                    )
( *P When opening a console device the parameters to OPEN-GEN have the  )
( ** following meaning:                                                 )
( *E    ADDR            Width in characters of the display window.      )
( **    LEN             Height in characters of the display window.     )
( **    ATTRIBS         Character Font point size to use for display.   )
\ =======================================================================


\ =======================================================================

EXTERN: int PASCAL lMessageBeep( int );
EXTERN: HANDLE PASCAL CreateFont( int, int, int, int, int, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, LPCTSTR );
EXTERN: HDC PASCAL GetDC( HWND );
EXTERN: int PASCAL ReleaseDC( HWND, HDC );
EXTERN: HANDLE PASCAL SelectObject( HDC, HANDLE );
EXTERN: BOOL PASCAL GetTextExtentPoint( HDC, LPCTSTR, int, void *);
EXTERN: int PASCAL DeleteObject( HANDLE );
EXTERN: void PASCAL *GlobalAlloc( DWORD, int );
EXTERN: HDC PASCAL BeginPaint( HWND, void *);
EXTERN: int PASCAL EndPaint( HWND, void *);
EXTERN: DWORD PASCAL SetTextColor( HDC, DWORD );
EXTERN: DWORD PASCAL SetBkColor( HDC, DWORD );
EXTERN: int PASCAL GetClientRect( HWND, void *);
EXTERN: int PASCAL GetWindowRect( HWND, void *);
EXTERN: int PASCAL AdjustWindowRect( void *, DWORD, BOOL );
EXTERN: int PASCAL RedrawWindow( HWND, void *, void *, int );
EXTERN: int PASCAL GlobalFree( HANDLE );
EXTERN: HDC PASCAL CreateCompatibleDC( HDC );
EXTERN: BOOL PASCAL DeleteDC( HDC );
EXTERN: int PASCAL BitBlt( HDC, int, int, int, int, HDC, int, int, UINT );
EXTERN: BOOL PASCAL ShowCaret( HWND );
EXTERN: BOOL PASCAL HideCaret( HWND );
EXTERN: BOOL PASCAL SetCaretPos( int, int );
EXTERN: BOOL PASCAL CreateCaret( HWND, HANDLE, int, int );

struct SIZE
        cell    field   SIZE.cx
        cell    field   SIZE.cy
end-struct

\ =======================================================================

: RGB                   \ red green blue -- COLORREF
  $FF and $10 LSHIFT rot
  $FF and rot
  $FF and $8 LSHIFT or or
;


-1              constant CONSOLE_COLOR_PRESERVE
$00 $00 $00 RGB constant CONSOLE_COLOR_BLACK
$DF $DF $DF RGB constant CONSOLE_COLOR_LTGRAY
$FF $FF $FF RGB constant CONSOLE_COLOR_WHITE
$FF $00 $00 RGB constant CONSOLE_COLOR_RED
$00 $FF $00 RGB constant CONSOLE_COLOR_GREEN
$00 $00 $FF RGB constant CONSOLE_COLOR_BLUE

1 cells constant COLORREF

WS_POPUP
WS_CAPTION or
WS_POPUP or
WS_BORDER or
constant dwConsoleStyle

CONSOLE_COLOR_BLACK     constant        defaultBack
CONSOLE_COLOR_GREEN     constant        defaultFore
bl                      constant        defaultChar

\ =======================================================================

: CreateConsoleFont     \ size -- hFont | 0
  ( size )
  0
  0
  0
  FW_THIN
  FALSE
  FALSE
  FALSE
  ANSI_CHARSET
  OUT_DEFAULT_PRECIS
  CLIP_DEFAULT_PRECIS
  DEFAULT_QUALITY
  FF_MODERN
  Z" Courier"
  CreateFont
;

: GetActualFontSize     \ hFont -- width height TRUE | FALSE

                        { hFont | oldfont dc sz[ SIZE ] w1 h1 w2 h2 -- }

  NULL GetDC -> dc
  dc hFont SelectObject -> oldfont

  dc Z" M" 1 sz[ GetTextExtentPoint drop
  sz[ SIZE.cx @ -> w1
  sz[ SIZE.cy @ -> h1

  dc Z" I" 1 sz[ GetTextExtentPoint drop
  sz[ SIZE.cx @ -> w2
  sz[ SIZE.cy @ -> h2

  dc oldfont SelectObject drop
  NULL dc ReleaseDC drop

  w1 w2 <> if FALSE exit then
  h1 h2 <> if FALSE exit then

  w1 h1 TRUE
;

\ =======================================================================

: AllSameColor?         \ b1 b2 count -- flag
                        { b1 b2 count | c1 c2 -- flag }
  b1 @ -> c1
  b2 @ -> c2
  count 0 ?do
    b1 i cells + @ c1 <> if false unloop exit then
    b2 i cells + @ c2 <> if false unloop exit then
  loop
  true
;

: paint-to-dc           \ hwnd hdc --

                        { hWnd hdc | of hFont width height *c *f *b px py dx dy -- }

  hWnd Z" WIDTH-IN-CHARS"  GetProp -> width
  hWnd Z" HEIGHT-IN-CHARS" GetProp -> height
  hWnd Z" CONSOLE-MEMORY"  GetProp -> *c
  hWnd Z" DISPLAY-FONT"    GetProp -> hFont

  *c width height * chars + -> *f
  *f width height * COLORREF * + -> *b

  hdc hFont SelectObject -> of
  hFont GetActualFontSize drop -> dy -> dx
  0 -> px 0 -> py

  \ WIDTH and HEIGHT : Character width and height of console area
  \ *C               : Pointer to beginning of character array
  \ *F               : Pointer to beginning of foreground color array
  \ *B               : Pointer to beginning of background color array
  \ HFONT            : Render Font
  \ of               : Old DC Font
  \ dx               : font character width
  \ dy               : font character height
  \ px               : current x position in client area (pixels)
  \ py               : current y position in client area (pixels)

  height 0 ?do

    *f *b width AllSameColor?
    if
        hdc *f @ SetTextColor drop
        hdc *b @ SetBkColor drop
        hdc px py *c width TextOut drop
        *c width chars + -> *c
        *f width cells + -> *f
        *b width cells + -> *b
        0 -> px
    else
      width 0 ?do
        hdc *f @ SetTextColor drop
        hdc *b @ SetBkColor drop
        hdc px py *c 1 TextOut drop

        dx px + -> px
        *c 1 chars + -> *c
        *f 1 cells + -> *f
        *b 1 cells + -> *b
      loop
    then

    0 -> px
    dy py + -> py
  loop

  \ Done, tidy up and go

  hdc of SelectObject drop
;

\ =======================================================================

: paint-console         \ hwnd --

                        { hWnd | ps[ PAINTSTRUCT ] r[ RECT ] -- }

  hWnd HideCaret drop
  hWnd ps[ BeginPaint
  hWnd swap paint-to-dc
  hWnd ps[ EndPaint drop
  hWnd ShowCaret drop
;

: key-pressed           \ hwnd wparam --
  over Z" KEYINBUFFER" -1 SetProp drop
  #255 and Z" KEYBUFFER" swap SetProp drop
;

#4 #1 callback: wndprocConsole
:noname                 \ hwnd Message wParam lParam -- res
  2 pick case
    WM_CHAR  of drop nip key-pressed 0     endof
    WM_PAINT of 2drop drop paint-console 0 endof
    WM_SETFOCUS of 2drop drop
                        dup Z" DISPLAY-FONT" GetProp GetActualFontSize drop nip >r
                        dup NULL 0 r> CreateCaret drop
                        ShowCaret drop                  endof
    WM_KILLFOCUS of 2drop drop HideCaret drop endof
    drop DefWindowProc
  end-case
; to-callback wndprocConsole

\ =======================================================================

: MakeWindow            \ -- hwnd | 0

                        { | wc[ WNDCLASS ] -- }

  CS_HREDRAW CS_VREDRAW or      wc[ WNDCLASS.style !
  wndprocConsole                wc[ WNDCLASS.lpfnwndproc !
  0                             wc[ WNDCLASS.cbclsextra !
  0                             wc[ WNDCLASS.cbwndextra !
  NULL GetModuleHandle          wc[ WNDCLASS.hinstance !
  NULL IDI_APPLICATION LoadIcon wc[ WNDCLASS.hIcon !
  NULL IDC_ARROW LoadCursor     wc[ WNDCLASS.hcursor !
  NULL                          wc[ WNDCLASS.hbrbackground !
  NULL                          wc[ WNDCLASS.lpszmenuname !
  Z" CONSOLECLASS"              wc[ WNDCLASS.lpszclassname !

  wc[ RegisterClass drop

  NULL
  Z" CONSOLECLASS"
  Z" Console"
  dwConsoleStyle
  CW_USEDEFAULT
  CW_USEDEFAULT
  CW_USEDEFAULT
  CW_USEDEFAULT
  NULL
  NULL
  NULL GetModuleHandle
  NULL CreateWindowEx
;

: SizeAndShowWindow     \ hwnd client-width client-height --

                        { hwnd cw ch | r[ RECT ] -- }

  0 r[ rect.top !
  0 r[ rect.left !
  cw r[ rect.right !
  ch r[ rect.bottom !

  r[ dwConsoleStyle false AdjustWindowRect drop

  hwnd
  r[ rect.left @ 0 max
  r[ rect.top @  0 max
  r[ rect.right @ r[ rect.left @ -
  r[ rect.bottom @ r[ rect.top @ -
  true MoveWindow drop

  hwnd SW_NORMAL ShowWindow drop
;

\ =======================================================================

: MakeConsoleArray      \ width height -- ptr | 0

                        { width height | size p tp -- }

  width height *
  COLORREF 2 * 1 chars + * -> size

  GPTR size GlobalAlloc dup -> p
  if

        p -> tp                         \ prefill character area with <space>
        width height * 0 ?do
                defaultChar tp c!
                tp 1 chars + -> tp
        loop

        width height * 0 ?do            \ prefill foreground colors
                defaultFore tp !
                tp 1 cells + -> tp
        loop

        width height * 0 ?do            \ prefill background colors
                defaultBack tp !
                tp 1 cells + -> tp
        loop

  then

  p
;

\ =======================================================================

: CreateConsoleWindow   \ size width(chars) height(chars) -- hWnd | 0

                        { fsize width height | hFont cwidth cheight hwnd cbuffer -- }

  \ Step#1 Make a memory array for the characters and colors within the
  \        "console" display
  \        Array is organised as
  \                     WIDTH*HEIGHT    8 bit ASCII for character
  \        followed by
  \                     WIDTH*HEIGHT    COLORREF (character foregrounds)
  \        followed by
  \                     WIDTH*HEIGHT    COLORREF (character background)

  width height MakeConsoleArray dup -> cbuffer
  NULL = if 0 exit then

  \ Step#2 Create My fixed display font

  fsize CreateConsoleFont dup -> hFont
  NULL = if 0 exit then

  \ Step#3 Get Actual pixel dimensions of character

  hFont GetActualFontSize
  if
        -> cheight -> cwidth
  else
        0 exit
  then

  \ Step#4 Go off and make me a window

  MakeWindow dup -> hWnd
  NULL = if hFont DeleteObject drop 0 exit then

  \ Step#5 Store Window Local Information ( char size, hFont etc )
  hWnd Z" DISPLAY-FONT"    hFont   SetProp drop
  hWnd Z" WIDTH-IN-CHARS"  width   SetProp drop
  hWnd Z" HEIGHT-IN-CHARS" height  SetProp drop
  hWnd Z" CONSOLE-MEMORY"  cbuffer SetProp drop
  hWnd Z" CURSORX"         0       SetProp drop
  hWnd Z" CURSORY"         0       SetProp drop
  hWnd Z" KEYBUFFER"       0       SetProp drop
  hWnd Z" KEYINBUFFER"     0       SetProp drop
  hwnd Z" CHANGED"         -1      SetProp drop

  \ Step#6 Size Window based on character with and console char-size
  \        then SHOW it

  hWnd
  width  cwidth  *
  height cheight *
  SizeAndShowWindow

  \ Done

  hwnd
;

\ =======================================================================

: ConsoleUpdate                 \ hwnd --
  dup >r
  Z" CHANGED" GetProp if
    r@ NULL NULL RDW_INVALIDATE RedrawWindow drop
    r@ Z" CHANGED" 0 SetProp drop
  then
  r> drop
;

\ =======================================================================

: ConsoleGetXY                  \ hwnd -- x y
  dup Z" CURSORX" GetProp
  swap Z" CURSORY" GetProp
;

: ConsoleSetXY                  \ hwnd x y --

  2 pick Z" DISPLAY-FONT" GetProp GetActualFontSize drop        \ hwnd x y wc hc --
  2over                         \ hwnd x y wc hc x y
  rot *                         \ hwnd x y wc x y*
  -rot *                        \ hwnd x y y* x*
  swap SetCaretPos drop

  rot tuck                      \ x hwnd y hwnd
  Z" CURSORY" rot SetProp drop
  Z" CURSORX" rot SetProp drop
;

: ConsoleInRange?               \ hwnd x y -- flag
  rot dup Z" WIDTH-IN-CHARS" GetProp    \ x y hwnd width
  swap Z" HEIGHT-IN-CHARS" GetProp      \ x y width height
  rot >=                                \ x width height>=y
  -rot < and
;

\ =======================================================================

: ConsoleClear                  \ hwnd --
                                { hwnd | -- }

  hwnd Z" CONSOLE-MEMORY" GetProp GlobalFree drop

  hwnd Z" WIDTH-IN-CHARS" GetProp
  hwnd Z" HEIGHT-IN-CHARS" GetProp
  MakeConsoleArray Z" CONSOLE-MEMORY" hwnd -rot SetProp drop
  hwnd Z" CHANGED" -1 SetProp drop
  hwnd ConsoleUpdate
;

\ =======================================================================

: Console>buffers               \ hwnd x y -- *cb *fc *bc
                                { hwnd cx cy | *cb *fc *bc -- }

  hWnd Z" CONSOLE-MEMORY" GetProp -> *cb
  hWnd Z" WIDTH-IN-CHARS" GetProp dup >r
  hWnd Z" HEIGHT-IN-CHARS" GetProp *            \ size-in-chars --
  dup chars *cb + -> *fc
  cells *fc + -> *bc

  cy r> * cx + >r                       \ -- ; R: offset-in-chars --

  *cb r@ chars +
  *fc r@ cells +
  *bc r> cells +
;

\ =======================================================================

: Console?scroll                \ hwnd --
                                { hwnd | cury wic scroll-size-in-chars d_cb d_fc d_bc -- }

  hwnd ConsoleGetXY nip -> cury
  hWnd Z" HEIGHT-IN-CHARS" GetProp

  cury over < if drop exit then

  1-
  hWnd Z" WIDTH-IN-CHARS" GetProp dup -> wic
  * -> scroll-size-in-chars

  hwnd 0 0 Console>Buffers
  -> d_bc -> d_fc -> d_cb

  hwnd 0 1 Console>Buffers      \ s_cb s_fc s_bc --
  d_bc scroll-size-in-chars cells move
  d_fc scroll-size-in-chars cells move
  d_cb scroll-size-in-chars move

  \ And backtrack cursor position
  hWnd dup ConsoleGetXY nip 1- 0 swap ConsoleSetXY

  \ fill last line with default
  d_cb scroll-size-in-chars +
  wic chars bounds ?do defaultCHAR i c! loop

  d_fc scroll-size-in-chars +
  wic cells bounds ?do defaultFore i ! 1 cells +loop

  d_bc scroll-size-in-chars +
  wic cells bounds ?do defaultBack i ! 1 cells +loop

  hwnd Z" CHANGED" -1 SetProp drop
;

\ =======================================================================

: ConsoleDefaultChar            \ hwnd char fore back --

                                { hwnd ch fc bc | *cb *fc *bc -- }

  hwnd ConsoleGetXY
  2dup hwnd -rot ConsoleInRange? 0= if 2drop exit then

  hwnd -rot Console>buffers -> *bc -> *fc -> *cb

  ch *cb c!
  fc -1 <> if fc *fc ! then
  bc -1 <> if bc *bc ! then

  hwnd dup ConsoleGetXY swap 1+ swap ConsoleSetXY
;

: ConsoleWriteChar              \ hwnd char fc bc --

                                { hwnd ch fc bc | -- }

  ch case
    #7  of      0 MessageBeep drop                                      endof
    #8  of      hwnd dup ConsoleGetXY swap 1- 0 max swap ConsoleSetXY   endof
    #9  of      hwnd dup ConsoleGetXY swap 7 + -8 and swap ConsoleSetXY endof
    #10 of      hwnd dup ConsoleGetXY
                1+ ConsoleSetXY
                hwnd Console?scroll
                hwnd ConsoleUpdate                                      endof
    #12 of      hwnd ConsoleClear hwnd 0 0 ConsoleSetXY                 endof
    #13 of      hwnd dup ConsoleGetXY nip 0 swap ConsoleSetXY
                hwnd Z" CHANGED" -1 SetProp drop                        endof

    drop
    hwnd ch fc bc ConsoleDefaultChar
  end-case
  hwnd Z" CHANGED" -1 SetProp drop
;

\ =======================================================================

: ConsoleKeyInBuffer?           \ hwnd -- flag
  Z" KEYINBUFFER" GetProp 0<>
;

: ConsoleKeyBuffer@             \ hwnd -- flag
  dup Z" KEYBUFFER" GetProp
  swap Z" KEYINBUFFER" 0 SetProp drop
;

\ =======================================================================
\
\ The Generic IO device handlers
\
\ =======================================================================

struct gconsole-sid
  gen-sid +                     \ reuse field names of GEN-SID
  COLORREF field gen-forecolor
  COLORREF field gen-backcolor
end-struct

\ =======================================================================

: gconsole-open         \ width height charsize SID -- sid ior

                        { addr len attribs sid | -- sid ior }

  attribs addr len CreateConsoleWindow
  dup sid gen-handle !
  0= if sid -1 exit then

  CONSOLE_COLOR_PRESERVE sid gen-forecolor !
  CONSOLE_COLOR_PRESERVE sid gen-backcolor !

  sid 0
;

: gconsole-close        \ sid -- ior
  gen-handle @ DestroyWindow drop 0
;

\ =======================================================================

: gconsole-read         \ addr len sid -- ior
  drop 2drop -1
;

: gconsole-write        \ addr len sid -- ior
  drop 2drop -1
;

: gconsole-flushOP      \ sid -- ior
  gen-handle @ ConsoleUpdate 0
;

\ =======================================================================

: gconsole-key?         \ sid -- flag
  dup gconsole-flushop drop
  busyidle
  gen-handle @ ConsoleKeyInBuffer?
;

: gconsole-key          \ sid -- char
  begin
    dup gconsole-key?
  until
  gen-handle @ ConsoleKeyBuffer@
;

: gconsole-ekey?        \ sid -- flag
  drop false
;

: gconsole-ekey         \ sid -- char
  begin
    dup gconsole-ekey?
  until
  drop
  0
;

: gconsole-accept       { address maxlen sid | len -- len' }

  0 -> len

  address maxlen bounds ?do
    key case

      #8 of                                     \ <BACKSPACE>
        len 0<> if                              \ if not at left edge
          len 1- -> len                         \ decrement length
          #8 emit                               \ emit backspace char
          #32 emit
          #8 emit
          -1                                    \ +LOOP modification -1
        else
          0                                     \ Don't increment Loop
        then
      endof

      #9 of                                     \ <TAB>
        bl dup emit i c!                        \ treat as space
        len 1+ -> len
        1
      endof

      #13 of                                    \ <CR>
        bl dup emit                             \ output a <SPACE>
        i c!                                    \ store on end of string
        leave                                   \ and leave
      endof

      dup emit                                  \ DEFAULT
      i c!                                      \ store char in buffer
      len 1+ -> len                             \ increment string length
      1                                         \ modify address by 1 (+LOOP)

    end-case
  +loop

  len
;

\ =======================================================================

: gconsole-emit         \ character sid --

  dup >r gen-handle @           \ character hWnd -- ; R: sid --
  swap r@ gen-forecolor @
       r> gen-backcolor @ ConsoleWriteChar
  1 out +!
;

: gconsole-emit?        \ sid -- flag
  drop true
;

: gconsole-type         \ addr len sid --
  -rot bounds ?do
    i c@ over gconsole-emit
  loop
  drop
;

: gconsole-cr           \ sid --
  #13 over gconsole-emit
  #10 swap gconsole-emit out off
;

: gconsole-lf           \ sid --
  #10 swap gconsole-emit
;

: gconsole-ff           \ sid --
  #12 swap gconsole-emit
;

: gconsole-bs           \ sid --
  #8 swap gconsole-emit
;

: gconsole-bell         \ sid --
  #7 swap gconsole-emit
;

\ =======================================================================

: gconsole-setpos       \ x y attribs sid -- ior
  nip gen-handle @ -rot ConsoleSetXY
  #0
;

: gconsole-getpos       \ attribs sid -- x y ior
  nip gen-handle @ ConsoleGetXY
  #0
;

\ =======================================================================

: gconsole-ioctl        \ addr len fn sid -- ior
  2drop 2drop 0
;

\ =======================================================================

: gconsole-RFU          \ --
  -401 throw
;

: gconsole-init         \ addr len sid -- ior
  -401 throw
;

: gconsole-term         \ sid -- ior
  -401 throw
;

: gconsole-config       \ sid -- ior
  -401 throw
;

\ =======================================================================

create gconsole-vectors
  ' gconsole-open ,                     \ Done
  ' gconsole-close ,                    \ Done
  ' gconsole-read ,                     \ null - bad result
  ' gconsole-write ,                    \ null - bad result
  ' gconsole-Key ,                      \ null - will never return
  ' gconsole-Key? ,                     \ Done
  ' gconsole-Ekey ,                     \ null - will never return
  ' gconsole-EKey? ,                    \ Done
  ' gconsole-Accept ,                   \ null - returns immediately
  ' gconsole-Emit ,                     \ Placeholder coded
  ' gconsole-Emit? ,                    \ Done
  ' gconsole-Type ,                     \ Done
  ' gconsole-CR ,                       \ Done
  ' gconsole-LF ,                       \ Done
  ' gconsole-FF ,                       \ Done
  ' gconsole-BS ,                       \ Done
  ' gconsole-Bell ,                     \ Done
  ' gconsole-setpos ,                   \ Done
  ' gconsole-Getpos ,                   \ Done
  ' gconsole-Ioctl ,                    \ Placeholder coded
  ' gconsole-FlushOP  ,                 \ Done
  ' gconsole-RFU ,                      \ Done
  ' gconsole-Init ,                     \ Done
  ' gconsole-Term ,                     \ Done
  ' gconsole-Config ,                   \ Done

\ =======================================================================
( *H Device Creation                                                    )
\ =======================================================================

: gconsole:             \ "name" -- ; Exec: -- sid
( *G Create a new text console device called "name" in the dictionary.  )
  create -1 , gconsole-vectors , 0 , 0 ,
;

\ =======================================================================
( *> ###                                                                )
\ =======================================================================










\ =======================================================================


\ gconsole: testdev
\
\ : t1
\   winapphandle@ SW_HIDE ShowWindow drop
\   testdev dup op-handle ! ip-handle !
\   80 25 18 open-gen 2drop
\   72 c/line !
\   .cold
\ ;
\
\ : rf    CONSOLE_COLOR_RED    testdev gen-forecolor !       ;
\ : gf    CONSOLE_COLOR_GREEN  testdev gen-forecolor !       ;
\ : wf    CONSOLE_COLOR_LTGRAY testdev gen-forecolor !       ;
\ : bb    CONSOLE_COLOR_BLUE   testdev gen-backcolor !       ;
\ : kb    CONSOLE_COLOR_BLACK  testdev gen-backcolor !       ;
\
\ t1
\
\
\
\
\
\
\
\
\ also system definitions
\ : (words)       \ #thread nfa -- flag                           SYS.0000
\   dup name> immediate? if rf else gf then
\   nip .name
\   #16 out @ #15 and - spaces
\   TRUE
\   out @ c/line @ >= if
\     cr
\     halt? if
\       drop FALSE
\     then
\   then
\ ;
\ previous definitions
\
\ : WORDS         \ --                                             MPE.0000
\ ( *G Display names of all definitions in wid at top of search-order     )
\   cr
\   [ also system ]
\   ['] (words)
\   [ previous ]
\   context @ WalkWordList
\ ;
\