\ Motorola S3 generator

pto

Motorola S-record downloader - converts a file to
S record format and makes output file

Originally issued as DOWN-LOAD in XC-COMM suite
Converted to stand-alone use: RGG: 18/11/92



\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  

hex

0200 constant buffer-length				\ length of convert buffer
create load-buffer buffer-length allot			\ actual convert buffer

pcb op-file						\ file to write to
  "" op.mot" op-file set-pathname			\ default name
pcb load-file						\ file to read from

variable checksum					\ ongoing checksum store
variable length						\ #bytes in this record
variable host-address					\ address to read from in buffer

2variable target-address				\ address for target addr in record

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

hex

: .hex				\ n -- ; send as xx
  base @ >r hex					\ preserve base, force hex
  s>d <# # # #> type				\ make two hex digits and print
  r> base !					\ restore base
;

: char-target			\ char -- ; send this to target file
  emit
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

: send-cr		\ -- ; send a cr to file
  0d emit				\ done manually just to make sure correct
  0a emit
;

: bin-ascii		\ byte -- ; convert to ascii char
  0f and  dup 9 >			\ test if A..F
  if
    037 +				\ offset from ascii A
  else
    030 +				\ offset from ascii 0
  endif  
;

: byte-ascii		\ byte -- low high ; convert to two chars in right order
  0ff and dup bin-ascii
  swap 10 /  bin-ascii  
;

: sum-check		\ n -- ; add n to checksum
  checksum +!  
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

: 0>check			\ -- ; reset checksum
  0 checksum !  
;

: byte-target			\ byte -- ; send a byte and incr checksum
  dup 0ff and sum-check
  byte-ascii emit emit
;

: word-target			\ n -- ; send this 16-b word
  0 0100 um/mod					\ -- low high
  byte-target byte-target  			\ send in motorola order
;

: header			\ -- ; send record header
  ascii S char-target				\ S
  ascii 3 char-target  				\ 3
;

: record-length			\ -- ; send #bytes in record
  length @ 5 + byte-target  			\ #data-bytes + 1 c/s + 4 addr
;

: start-address			\ -- ; send start addr
  target-address 2@			\ get the double address
  word-target				\ send high word
  word-target				\ send low word
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

: data				\ -- ; send data in record
  host-address @ length @ +   host-address @
  do
    i c@ byte-target
  loop  
;

: send-check			\ -- ; send the checksum
  checksum @  0ff xor			\ negate
  byte-target  0>check  		\ send and reset
;

: send-record			\ -- ; send the next record
  header				\ send header
  0>check				\ zero the checksum
  record-length start-address		\ send length and start addr
  data send-check send-cr		\ send data, checksum and cr
;

: send-last-record		\ -- ; send the terminator record
  ascii S emit   ascii 7 emit			\ send S7 text
  05 .hex					\ send 05 as length of record
  00 .hex 00 .hex 00 .hex 00 .hex		\ send 0000 as 32b address 
  0fa .hex					\ cheksum for S70500000000xx
  send-cr					\ finish off with CR
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

: send-blocks			\ -- ; send data blocks
  begin
    load-buffer buffer-length erase				\ preset to zero
    load-buffer buffer-length load-file handle read-path	\ read a buffers worth
    0= swap 0<> and						\ while there is still data
   while
    load-buffer host-address !					\ set start addr for data
    020 length !						\ set length of a record
    buffer-length 020 / 0					\ in steps of 20 thru buffer
    do
      send-record						\ send the next record
      020 host-address +!					\ and step on
      020 s>d target-address 2@ d+ target-address 2!		\ ditto
    loop							\ do for all of buffer
  repeat  							\ quit when no more in file
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  Motorola S-record downloader

: down-load		\ -- ; send the data
  send-blocks					\ send most records
  send-last-record				\ send the terminator
;

\ -----End of Page-----
\ -- R.G.G -- 18/11/92 --  application -- new version

: redirect>screen	\ -- ; place output back to screen
  assign dir-emit to-do emit
  assign dir-type to-do type
;

: bye-bye		\ -- ; quit
  redirect>screen			\ back to screen if not already
  1 cooked				\ reset op and ip streams
  0 cooked
  f#04c					\ and back to dos
;

: get-source		\ <name> -- ; set source name
  bl word
  dup "" /?" $=				\ test against help switch
  if
    cr ." Usage:   S3 <source> <dest> <start-addr>" bye-bye
  endif
  dup c@ 0=				\ if null
  if
    cr ." Usage:   S3 <source> <dest> <start-addr>"
    cr ." Use    S3 /?     for help" bye-bye
  endif
  load-file set-pathname	\ get source name
;

: get-dest		\ <name> -- ; set dest file name
  bl word op-file set-pathname		\ get dest file name
;

: get-addr		\ <addr> -- ; set this as dest addr
  base @ >r  hex			\ preserve base, convert in hex
  bl word number?			\ get the text
  case
    0 of ." Error: Invalid start address" bye-bye endof		\ no num : error
    1 of s>d target-address 2!  endof				\ single, convert to double
    2 of target-address 2!  endof					\ double already ok
  endcase
  r> base !				\ restore base
;

: file-emit		\ char -- ; send this char to file
  here c!				\ place char somewhere
  here 1 op-file handle write-path	\ write to file
  0<> swap 1 <> or			\ if error
  if
    redirect>screen
    ." Error: Cant write to file." bye-bye		\ then quit
  endif
;

: file-type		\ addr len -- ; send these bytes to file
  op-file handle write-path			\ write to file
  nip 0<>					\ if error
  if
    redirect>screen
    ." Error: Cant write to file." bye-bye	\ the say so
  endif
;

: redirect>file		\ -- ; set emit and type to go to o/p file
  assign file-emit to-do emit
  assign file-type to-do type
;

: make-file		\ -- ; make the output file
  op-file create-path-pcb			\ try to create it
  if						\ if error
    ." Error: Cant create target file." bye-bye		\ then say so and quit
  endif
;

: open-source		\ -- ; open the source file
  load-file open-path-pcb		\ try to open it
  if					\ if cant
    ." Error: Cant open source file." bye-bye		\ say so and quit
  endif
;

: signon		\ -- ; say who we are
  ." Binary -> Motorola S3 Converter   v1.000"
  cr ." (c) MicroProcessor Engineering Ltd, 1992"
  cr
;

: make-mot		\ -- ; application level word
  signon				\ say what this is
  get-source				\ get source name
  get-dest				\ get dest file name
  get-addr				\ get the dest addr
  open-source				\ open the source file
  make-file				\ create the o/p file
  redirect>file				\ set o/p to file
  down-load
  redirect>screen			\ back to screen at the end
  bye-bye				\ finish cleanly
;

assign noop to-do cls			\ so the screen doesnt clear

assign make-mot to-do loader		\ make turnkey

save s3					\ save executable

decimal
